c
c
c         Main program for Magellan
c         guider camera.
c         -------------------------
c
       implicit none
c
       real*4    r4 (3)
       integer*4 num
       integer*4 rmvec
       integer*4 dspini, dsperr
       integer*4 dspflg (47), dspval (47)
       integer*4 pctsav
       integer*4 pctset, pctval, pctprv
       integer*4 dcur
       logical*4 apaflg, esflg
       integer*4 test, cmd
       logical*4 mgcsr, ok
       character pbxmsg*24
       character alph*8
       logical*4  negflag
       character*24  c24
c
       common / dspcom / dspini, dsperr, dspflg, dspval
       common / pctcom / pctset, pctval, pctprv
       common / flgcom / apaflg, esflg
c
       data apaflg / .true. /, esflg / .false. /
       data dcur / 40 /
c
c
c
c         Perform program initialization.
c         -------------------------------
c
       call gcset (rmvec)
       call vbox  (15)
       call vbox  (51, dcur)
       pctsav = pctval
       if (apaflg) then
           call cbox (13, 1)
       else
           call cbox (13, 0)
       endif
c
c
c         Start of main control loop.
c         ---------------------------
c
  200  continue
c
c
c         Update the prompt box.
c         ----------------------
c
       call pbox (5)
c
c
c         Update the system message box.
c         ------------------------------
c
       call dspmsg
c
c
c         Update civil time.
c         ------------------
c
       call utclk
c
c
c         Check for mouse input.
c         ----------------------
c
       call mcheck
c
c
c         Initialize the DSP a
c         little bit at a time.
c         ---------------------
c
       if     (dspini .eq. 1) then
          call dspload
c
c
c         If the DSP is running, do
c         something with it.
c         -------------------------
c
       elseif (dspini .ge. 2) then
          call dsprun
       endif
c
c
c         Process TCP uplink.
c         -------------------
c
       call tcp
c
c
c         On-screen image display.
c         ------------------------
c
       call screen
c
c
c         TCS communication.
c         ------------------
c
       call tcs
c
c
c         Check for commands.
c         -------------------
c
       test = cmd (alph, num, r4, negflag, c24)
       if (test .eq. 0) go to 200

       ok = mgcsr (test, alph, num, r4, negflag, pbxmsg, c24)
       if (.not. ok) call pbox (2, pbxmsg)
c
c
c         Exit - restore clock rate
c         and interrupt vector.
c         -------------------------
c
       if (alph .eq. 'exit    ') then
c
          call outp (x'43', x'36')
          call outp (x'40', x'00')
          call outp (x'40', x'00')
c
          call clock0 (rmvec)
c
          stop
       endif
 
       go to 200
c
       end
c
c
c
c         Main command service routines
c         Magellan guider camera.
c         -------------------------
c
       logical*4 function mgcsr (test, alph8, num, r4, negflag,
     :   pbxmsg, c24)

       implicit none
c
       logical*4 negflag
       character c24*(*)
       real*4    r4 (3), sens, pa, px
       integer*4 num, i4
       integer*4 dspini, dsperr, zero, bkgset
       integer*4 avpf, avps, binf, bins
       integer*4 zzero, zspan, icur, dcur
       integer*4 incur, xcur (5), ycur (5)
       integer*4 dspflg (47), dspval (47)
       integer*4 exptim, runtim, acqtim
       integer*4 xfsflg, exftim, exstim
       integer*4 sndtim, stime, pctset, pctval, pctprv
       integer*4 gdrfl, xflip, yflip, box
       integer*4 test, cmd, brwsptr, scrnptr
       integer*4 gain, usec, hdir, tec, gate
       integer*4 timer1, timer2, timer3, timer4
       integer*4 sendct, sendsz, sndbuf (250000)
       integer*4 skyval, skybuf (300000)
       integer*4 shflag
       logical*4 sendfl, brwsfl, skyflg, subflg
       logical*4 apaflg, esflg
       character alph8*8
       character alph*4, msg*22
       character pbxmsg*24
       integer*4 scur, sxcur, sycur
       logical*4 movbox
       integer*4 chrcnt
       integer*4 savtf, savavf, savsnd
c
       integer*4 camnum
       common / cnncom / camnum
       integer*4 mmoden, mclick, fmoden, gmoden
       common / mmdcom / mmoden, mclick, fmoden, gmoden
       integer*4 camlen
       character*22 camcmd
       common / camcom / camlen, camcmd
       common / msgctl / brwsfl, brwsptr, scrnptr
       common / dspcom / dspini, dsperr, dspflg, dspval
       common / timcom / timer1, timer2, timer3, timer4
       common / skycom / skyflg, subflg, skyval, skybuf
       common / expcom / exptim, runtim, acqtim
       common / xfscom / xfsflg, exftim, exstim
       common / zptcom / zzero, zspan
       common / zrocom / zero, bkgset
       common / cr1com / incur, xcur, ycur
       common / avpcom / avpf, avps
       common / bincom / binf, bins
       common / sndcom / sendfl, sendct, sendsz, sndbuf
       common / sdtcom / sndtim, stime
       common / pctcom / pctset, pctval, pctprv
       common / ampcom / gain, usec, hdir, tec, gate
       common / gdrcom / gdrfl, sens, xflip, yflip, pa, px, box
       common / shmcom / shflag
       common / flgcom / apaflg, esflg
       common / movcom / movbox
c
       data icur / 5 /, dcur / 40 /
       data mmoden / 3 /, fmoden / 1 /, gmoden / 3 /
       data movbox / .false. /
c
       mgcsr = .true. 
       alph = alph8
c
c
c         Cursor keys: ctrl-<Up>.
c         -----------------------
c
       if (test .eq. -141) then
          brwsfl = .true.
          brwsptr = scrnptr - 1
          if (brwsptr .lt. 1) brwsptr = 1000 + brwsptr
          go to 200
       endif
c
c
c         ctrl-<Pg Up>.
c         -------------
c
       if (test .eq. -132) then
          brwsfl = .true.
          brwsptr = scrnptr - 5
          if (brwsptr .lt. 1) brwsptr = 1000 + brwsptr
          go to 200
       endif
c
c
c         ctrl-<Dn>.
c         ----------
c
       if (test .eq. -145) then
          brwsfl = .true.
          brwsptr = scrnptr + 1
          if (brwsptr .gt. 1000) brwsptr = brwsptr - 1000
          go to 200
       endif
c
c
c         ctrl-<Pg Dn>.
c         -------------
c
       if (test .eq. -118) then
          brwsfl = .true.
          brwsptr = scrnptr + 5
          if (brwsptr .gt. 1000) brwsptr = brwsptr - 1000
          go to 200
       endif
c
c
c         ctrl-<Home>.
c         ------------
c
       if (test .eq. -119) then
          brwsfl = .true.
          brwsptr = 5
          go to 200
       endif
c
c
c         ctrl-<End>.
c         -----------
c
       if (test .eq. -117) then
          if (brwsfl) then
             scrnptr = 0
             brwsfl = .false.
          endif
          go to 200
       endif
c
c
c         Cursor motions.  Whenever the cursors
c         move, erase them all and then re-draw
c         them.  If moving the magnifier box,
c         repaint the magnified window, too.
c
c         <Dn>.
c         -------------------------------------
c
       if (test .eq. -80) then
          call curfix
          i4 = ycur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Up>.
c         -----
c
       if (test .eq. -72) then
          call curfix
          i4 = ycur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Lf>.
c         -----
c
       if (test .eq. -75) then
          call curfix
          i4 = xcur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Rt>.
c         -----
c
       if (test .eq. -77) then
          call curfix
          i4 = xcur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Home>.
c         -------
c
       if (test .eq. -71) then
          call curfix
          i4 = xcur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          i4 = ycur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <End>.
c         ------
c
       if (test .eq. -79) then
          call curfix
          i4 = xcur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          i4 = ycur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Pg-Up>.
c         --------
c
       if (test .eq. -73) then
          call curfix
          i4 = xcur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          i4 = ycur (icur) - dcur
          if (icur .eq. 5) then
             i4 = max (i4, 400)
          else
             if (i4 .lt. 0) i4 = i4 + 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Pg-Dn>.
c         --------
c
       if (test .eq. -81) then
          call curfix
          i4 = xcur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 20, i4)
          xcur (icur) = i4
          i4 = ycur (icur) + dcur
          if (icur .eq. 5) then
             i4 = min (i4, 9600)
          else
             if (i4 .ge. 10000) i4 = i4 - 10000
          endif
          call vbox (icur + 30, i4)
          ycur (icur) = i4
          call curvid
          if (icur .eq. 5) then
             if (xfsflg .eq. 0) then
                call magnif
             else
                call dspset (- bins)
             endif
          else
             call curval (icur)
          endif
          go to 200
       endif
c
c
c         <Del>.
c         ------
c
       if (test .eq. -83) then
          if     (dcur .eq.  1) then
             dcur = 10
          elseif (dcur .eq. 10) then
             dcur = 40
          elseif (dcur .eq. 40) then
             dcur = 400
          endif
          call vbox (51, dcur)
          go to 200
       endif
c
c
c         <Ins>.
c         ------
c
       if (test .eq. -82) then
          if     (dcur .eq. 400) then
             dcur = 40
          elseif (dcur .eq.  40) then
             dcur = 10
          elseif (dcur .eq.  10) then
             dcur = 1
          endif
          call vbox (51, dcur)
          go to 200
       endif
c
c
c         Full-Frame: <F1>.  When changing
c         modes, save the %tile image value.
c         -----------------
c
       if ((test .eq. -59) .or. (alph .eq. 'fone')) then
          if (fmoden .eq. 2) then
              if (xfsflg .ne. 0) then
                 call dspset (binf)
              endif
              call cbox (11, 1)
              gdrfl = 1

              if ((sndtim .ne. 0) .or. (avpf .ne. 0) .or.
     :          (exftim .ne. 0)) then
                  savsnd = sndtim
                  sndtim = 0
                  stime = timer1
                  call vbox (60, 0)

                  savavf = avpf
                  avpf   = 0
                  call vbox (53, avpf)

                  savtf  = exftim
                  exftim = 0
                  if (xfsflg .eq. 0) exptim = exftim
                  call vbox (6, exftim * .0017165)
              endif
              go to 200
          else
              if (xfsflg .ne. 0) then
                 call dspset (binf)
              endif
              call cbox (11, 1)
              gdrfl = 1
              go to 200
          endif
       endif
c
c
c         Subraster (calc): <F2>.
c         -----------------------
c
       if ((test .eq. -60) .or. (alph .eq. 'ftwo')) then
          if (xfsflg .eq. 0) then
             call dspset (- bins)
          endif
          call cbox (11, 2)
          gdrfl = - 2
          go to 200
       endif
c
c
c         Subraster (move): <F3>.
c         -----------------------
c
       if ((test .eq. -61) .or. (alph .eq. 'fthr')) then
          if (fmoden .eq. 2) then
              if (xfsflg .ne. 0) then
                 call dspset (binf)
              endif
              call cbox (11, 1)
              gdrfl = 1

              exftim = savtf
              if (xfsflg .eq. 0) exptim = exftim
              call vbox (6, exftim * .0017165)

              avpf   = savavf
              call vbox (53, avpf)

              sndtim = savsnd
              stime = timer1
              call vbox (60, 0)
              go to 200
          else
              if (xfsflg .eq. 0) then
                 call dspset (- bins)
              endif
              call cbox (11, 3)
              gdrfl = - 3
              go to 200
          endif
       endif
c
c
c         Subraster (calc): <F4>.
c         -----------------------
c
       if ((test .eq. -62) .or. (alph .eq. 'ffou')) then
          movbox = .true.
          if (xfsflg .eq. 0) then
             call dspset (- bins)
          endif
          call cbox (11, 2)
          gdrfl = - 2
          go to 200
       endif
c
c
c         Subraster (move): <F5>.
c         -----------------------
c
       if ((test .eq. -63) .or. (alph .eq. 'ffiv')) then
          movbox = .true.
          if (xfsflg .eq. 0) then
             call dspset (- bins)
          endif
          call cbox (11, 3)
          gdrfl = - 3
          go to 200
       endif
c
c
c         GPC home <F8>
c         -----------------------
c
       if ((test .eq. -66) .or. (alph .eq. 'feig')) then
           camcmd = 'gphome0'
           camcmd(7:7) = char (48 + camnum)
           camlen = chrcnt (camcmd)
           go to 200
       endif
c
c
c         GPC field <F9>
c         -----------------------
c
       if ((test .eq. -67) .or. (alph .eq. 'fnin')) then
           camcmd = 'gpfld0'
           camcmd(6:6) = char (48 + camnum)
           camlen = chrcnt (camcmd)
           go to 200
       endif
c
c
c         GPC S/H <F10>
c         -----------------------
c
       if ((test .eq. -68) .or. (alph .eq. 'ften')) then
           camcmd = 'gpsha0'
           camcmd(6:6) = char (48 + camnum)
           camlen = chrcnt (camcmd)
           go to 200
       endif
c
c
c         TCS commands
c         ____________
c
       if (alph8(1:2) .eq. 'tc') then
           camcmd = c24(5:24)
           camlen = chrcnt (camcmd)
	   goto 200
       endif
c
c
c         Set image cursor position - absolute
c         ----------------------
c
       if ((alph .eq. 'xys ') .and. (num .eq. 3)) then
          scur = nint (r4 (1))
          sxcur = nint (r4 (2) * 10)
          sycur = nint (r4 (3) * 10)
          if ( .not. ((1 .le. scur) .and. (scur .le. 5))) then
             pbxmsg = 'cursor  is 1 to 5'
             mgcsr = .false.
             go to 200
          endif
          if ( .not. ((0 .le. sxcur) .and. (sxcur .le. 9999))) then
             pbxmsg = 'cursor X is 0 to 999.9'
             mgcsr = .false.
             go to 200
          endif
          if ( .not. ((0 .le. sycur) .and. (sycur .le. 9999))) then
             pbxmsg = 'cursor Y is 0 to 999.9'
             mgcsr = .false.
             go to 200
          endif
          call curupa (scur, sxcur, sycur)
          go to 200
       endif
c
c
c         Set image cursor position - relative
c         ----------------------
c
       if ((alph .eq. 'xyr ') .and. (num .eq. 3)) then
          scur = nint (r4 (1))
          sxcur = nint (r4 (2) * 10)
          sycur = nint (r4 (3) * 10)
          if ( .not. ((1 .le. scur) .and. (scur .le. 5))) then
             pbxmsg = 'cursor  is 1 to 5'
             mgcsr = .false.
             go to 200
          endif
          if ( .not. ((-9999 .le. sxcur) .and. (sxcur .le. 9999))) then
             pbxmsg = 'cursor X is -999.9 to 999.9'
             mgcsr = .false.
             go to 200
          endif
          if ( .not. ((-9999 .le. sycur) .and. (sycur .le. 9999))) then
             pbxmsg = 'cursor Y is -999.9 to 999.9'
             mgcsr = .false.
             go to 200
          endif
          call curupr (scur, sxcur, sycur)
          go to 200
       endif
c
c
c         Mouse mode.
c         ----------------------
c
       if ((alph .eq. 'mm  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ( .not. ((1 .le. i4) .and. (i4 .le. 3))) then
             pbxmsg = 'mode  is 1 to 3'
             mgcsr = .false.
             go to 200
          endif
          mmoden = i4
          call sbox (3, mmoden)
          go to 200
       endif
c
c
c         Function mode.
c         ----------------------
c
       if ((alph .eq. 'fm  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ( .not. ((1 .le. i4) .and. (i4 .le. 3))) then
             pbxmsg = 'mode  is 1 to 3'
             mgcsr = .false.
             go to 200
          endif
          fmoden = i4
          call sbox (4, fmoden)
          go to 200
       endif
c
c
c         Guide mode.
c         ----------------------
c
       if ((alph .eq. 'gm  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ( .not. ((1 .le. i4) .and. (i4 .le. 3))) then
             pbxmsg = 'mode  is 1 to 3'
             mgcsr = .false.
             go to 200
          endif
          gmoden = i4
          call sbox (5, gmoden)
          go to 200
       endif
c
c
c         Mouse click.
c         ----------------------
c
       if ((alph .eq. 'mc  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ( .not. ((1 .le. i4) .and. (i4 .le. 3))) then
             pbxmsg = 'click is 1 to 3'
             mgcsr = .false.
             go to 200
          endif
          mclick = i4
          go to 200
       endif
c
c
c         toggle automatic pa entry
c         -----------------------
c
       if (alph .eq. 'apa ') then
          apaflg = .not. apaflg
          if (apaflg) then
              call cbox (13, 1)
          else
              call cbox (13, 0)
          endif
          go to 200
       endif
c
c
c         toggle send extended guide corrections
c         -----------------------
c
       if (alph .eq. 'es  ') then
          esflg = .not. esflg
          if (esflg) then
              call cbox (14, 1)
          else
              call cbox (14, 0)
          endif
          go to 200
       endif
c
c
c         Initialize DSP.
c         ---------------
c
       if (alph .eq. 'dspi') then
          if (dspini .ne. 1) then
             dspini = 1
          else
             pbxmsg = '  dspi in progress'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Set the thermoelectric
c         cooler current.
c         ----------------------
c
       if ((alph .eq. 'tec ') .and. (num .eq. 1)) then
          if ((r4 (1) .ge. 0.) .and. (r4 (1) .le. 2.5)) then
             i4 = nint (r4 (1) / 5.e-3)
             i4 = 4096 + i4
             dspflg (x'1A') = 1
             dspval (x'1A') = i4
             tec = i4
             call vbox (1, r4 (1))
          else
             pbxmsg = '  range is 0. to 2.5'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Use left or right amplifier.
c         ----------------------------
c
       if ((alph .eq. 'amp ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if     (i4 .eq. 1) then
             dspflg (20) = 1
             dspval (20) = 1
             hdir = 1
             call vbox (64, 1)
             pbxmsg = '  right amp enabled'
             mgcsr = .false.
          elseif (i4 .eq. 2) then
             dspflg (20) = 1
             dspval (20) = 2
             hdir = 2
             call vbox (64, 2)
             pbxmsg = '  left amp enabled'
             mgcsr = .false.
          else
             pbxmsg = '  select amp 1 or 2'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Adjust output gate voltage.
c         ---------------------------
c
       if ((alph .eq. 'gate') .and. (num .eq. 1)) then
          if ((r4 (1) .le. -5.) .and. (r4 (1) .ge. -9.)) then
             i4 = 4096 + nint (200. * r4 (1))
             dspflg (27) = 1
             dspval (27) = i4
             gate = i4
             call vbox (65, r4 (1))
             msg = '  OG set to xxxx'
             call iform (i4, msg (13:16), 1)
             pbxmsg = msg
             mgcsr = .false.
          else
             pbxmsg = '  range is -5. to -9.'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Exposure time -- full frame.
c         ----------------------------
c
       if ((alph .eq. 'tf  ') .and. (num .eq. 1)) then
          if ((r4 (1) .ge. 0.) .and. (r4 (1) .le. 99.99)) then
             exftim = r4 (1) / .0017165
             if (xfsflg .eq. 0) exptim = exftim
             call vbox (6, r4 (1))
          else
             pbxmsg = '  range is 0. to 99.99'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Exposure time -- subraster.
c         ---------------------------
c
       if ((alph .eq. 'tg  ') .and. (num .eq. 1)) then
          if ((r4 (1) .ge. 0.) .and. (r4 (1) .le. 99.99)) then
             exstim = r4 (1) / .0017165
             if (xfsflg .eq. 1) exptim = exstim
             call vbox (7, r4 (1))
          else
             pbxmsg = '  range is 0. to 99.99'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Averaging parameter -- full frame.
c         ----------------------------------
c
       if ((alph .eq. 'avf ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((i4 .ge. 0) .and. (i4 .le. 99)) then
             avpf = i4
             call vbox (53, i4)
          else
             pbxmsg = '  range is 0 to 99'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Averaging parameter -- subraster.
c         ---------------------------------
c
       if ((alph .eq. 'avg ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((i4 .ge. 0) .and. (i4 .le. 99)) then
             avps = i4
             call vbox (54, i4)
          else
             pbxmsg = '  range is 0 to 99'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Pixel binning -- full frame.
c         ----------------------------
c
       if ((alph .eq. 'bf  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((i4 .eq. 2) .or. (i4 .eq. 4)) then
             if (binf .ne. i4) then
                if (xfsflg .eq. 0) call dspset (i4)
                binf = i4
                call vbox (55, binf)
             endif
          else
             pbxmsg = '  err: enter 2 or 4'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Pixel binning -- subraster.
c         ---------------------------
c
       if ((alph .eq. 'bg  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((i4 .eq. 2) .or. (i4 .eq. 4)) then
             if (bins .ne. i4) then
                if (xfsflg .ne. 0) call dspset (- i4)
                bins = i4
                call vbox (56, bins)
             endif
          else
             pbxmsg = '  err: enter 2 or 4'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         On-screen zero point.
c         ---------------------
c
       if ((alph .eq. 'zero') .and. (num .eq. 1)) then
          zzero = nint (r4 (1))
          call vbox (57, zzero)
          go to 200
       endif
c
c
c         On-screen span adjust.
c         ----------------------
c
       if ((alph .eq. 'span') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if (i4 .ne. 0) then
             zspan = i4
             call vbox (63, zspan)
          else
             pbxmsg = '  don''t enter 0!'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Percentile setting.
c         -------------------
c
       if ((alph .eq. 'pct ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((0 .le. i4) .and. (i4 .le. 99)) then
             pctset = i4
             call vbox (61, i4)
             if (i4 .eq. 0) call vbox (57, zzero)
          else
             pbxmsg = '  err, range is 0...99'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Background display intensity.
c         -----------------------------
c
       if ((alph .eq. 'bkg ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((1 .le. i4) .and. (i4 .le. 63)) then
             bkgset = i4
             call vbox (62, i4)
          else
             pbxmsg = '  err, range is 1...63'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Cursor select.
c         --------------
c
       if ((alph .eq. 'xy  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if ((1 .le. i4) .and. (i4 .le. 5)) then
             icur = i4
             call vbox (icur + 10)
          else
             pbxmsg = '  range is 1... 5'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         S-H mask flag
c         --------------
c
       if ((alph .eq. 'sh  ') .and. (num .eq. 1)) then
          shflag = nint (r4 (1))
          call vbox (66, shflag)
          go to 200
       endif
c
c
c         Send frame via TCP/IP link.
c         ---------------------------
c
       if ((alph .eq. 'send') .and. (num .le. 1)) then
          if (num .eq. 0) then
             if (sndtim .eq. 0) then
                if ((.not. sendfl) .and. (sendct .eq. -1)) then
                   sendfl = .true.
                else
                   pbxmsg = '  error, TCP link busy'
                   mgcsr = .false.
                endif
             else
                pbxmsg = '  error, timer enabled'
                mgcsr = .false.
             endif
c
          else
             i4 = nint (r4 (1))
             if ((0 .le. i4) .and. (i4 .lt. 1000)) then
                sndtim = i4
                stime = timer1
                call vbox (60, 0)
             else
                pbxmsg = '  timer range error'
                mgcsr = .false.
             endif
          endif
          go to 200
       endif
c
c
c         Pixel scale.
c         ------------
c
       if ((alph .eq. 'px  ') .and. (num .eq. 1)) then
          if ((0.01 .lt. r4 (1)) .and. (r4 (1) .le. 0.999)) then
             px = r4 (1)
             call cbox (8, px)
          else
             pbxmsg = '  range is 0.01... 0.999'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Position angle.
c         ---------------
c
       if ((alph .eq. 'pa  ') .and. (num .eq. 1)) then
          if ((0.0 .lt. abs (r4 (1)) ) .and.
     :        (abs (r4 (1)) .le. 360.)      ) then
             pa = r4 (1)
             call cbox (9, pa)
          elseif (r4 (1) .eq. 0.0) then
             pbxmsg = '  err: use '//char (241)//'360, not 0'
             mgcsr = .false.
          else
             pbxmsg = '  err: range is '//char (241)//'360'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Guider sensitivity.
c         -------------------
c
       if ((alph .eq. 'sn  ') .and. (num .eq. 1)) then
          if ((0.000000 .le. r4 (1)) .and. (r4 (1) .le. 2.0)) then
             sens = r4 (1)
             call cbox (10, sens)
          else
             pbxmsg = '  range is 0.1 to 2.0'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Guider box size.
c         ----------------
c
       if ((alph .eq. 'bx  ') .and. (num .eq. 1)) then
          i4 = nint (r4 (1))
          if (mod (i4, 2) .eq. 1) then
             box = i4
             call cbox (12, box)
          else
             pbxmsg = '  must be odd, 7... 69'
             mgcsr = .false.
          endif
          go to 200
       endif
c
c
c         Subtract sky.
c         -------------
c
       if ((alph .eq. 'sub ') .and. (num .eq. 0)) then
          if (subflg) then
             subflg = .false.
             call sbox (1, 0)
          else
             subflg = .true.
             call sbox (1, 1)
          endif
          go to 200
       endif
c
c
c         Store sky image.
c         ----------------
c
       if ((alph .eq. 'sky ') .and. (num .eq. 0)) then
          skyflg = .true.
          call sbox (2, 0)
          go to 200
       endif
c
c
c
       if (alph .eq. 'exit') then
c
          go to 200
       endif
c
       pbxmsg = '  command decode error'
       mgcsr = .false.
200    continue
c
       end
        integer*4 function chrcnt (string)
        character string *(*)

        integer*4 i

        n = len(string)
100     continue
        if (n .gt. 0) then
            if (string(n:n) .eq. ' ') then
                n = n-1
                goto 100
            endif
        endif
        chrcnt = n
        return
        end
