c
c
c         Subraster display box.
c         ----------------------
c
       subroutine sbox (fnc, arg)
c
       implicit  none
c
       integer*4 fnc, x0, xb, y0, yb
       integer*4 fptr, i4, i4val
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       character arg*(*)
       character*4 mmoden, fmoden, gmoden
c
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
c
       data  x0 / 216 /, y0 / 1 /, xb / 265 /, yb / 86 /
c
c
c         Subtract flag.
c         --------------
c
       if     (fnc .eq. 1) then
          i4 = i4val (arg)
          if (i4 .eq. 0) then
             fptr = blk1
          else
             fptr = grn1
          endif
          call opqchr1 ('sub', x0 +  92, y0 + 64, fontbuf (fptr))
c
c
c         Sky flag.
c         ---------
c
       elseif (fnc .eq. 2) then
          i4 = i4val (arg)
          if (i4 .eq. 0) then
             fptr = blk1
          else
             fptr = grn1
          endif
          call opqchr1 ('sky', x0 + 132, y0 + 64, fontbuf (fptr))
c
c
c         Mouse mode.
c         ---------
c
       elseif (fnc .eq. 3) then
          i4 = i4val (arg)
          mmoden = 'mm 0'
          mmoden(4:4) = char (i4+48)
          call opqchr1 (mmoden, x0 + 92, y0 + 48, fontbuf (blk1))
c
c
c         Function mode.
c         ---------
c
       elseif (fnc .eq. 4) then
          i4 = i4val (arg)
          fmoden = 'fm 0'
          fmoden(4:4) = char (i4+48)
          call opqchr1 (fmoden, x0 + 92, y0 + 32, fontbuf (blk1))
c
c
c         Guide mode.
c         ---------
c
       elseif (fnc .eq. 5) then
          i4 = i4val (arg)
          gmoden = 'gm 0'
          gmoden(4:4) = char (i4+48)
          call opqchr1 (gmoden, x0 + 92, y0 + 16, fontbuf (blk1))
c
       endif
c
       return
       end
c
c
c         Numerical values box.
c         ---------------------
c
       subroutine vbox (fnc, arg)
c
       implicit  none
c
       real*4    r4, r4val
       integer*4 i4, i4val, xyhi
       integer*4 fnc, x0, y0, xb, yb
       integer*4 y2, y3, y4, y5, y6, y7, y8, y9
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       character arg*(*), chr2*2, chr3*3, chr4*4, chr5*5
       character chr6*6
       character newtec*4, oldtec*4, newtmp*5, oldtmp*5
       character newfmn*5, oldfmn*5, newfvl*5, oldfvl*4
       character newfmx*5, oldfmx*5, newsdt*3, oldsdt*3
       character newfrm*4, oldfrm*4, newrow*3, oldrow*3
       character newexf*5, oldexf*5, newexs*5, oldexs*5
       character newrun*5, oldrun*5, newacq*5, oldacq*5
       character newval*5, oldval*5
       character*5 newzcr (4), oldzcr (4)
c
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
c
       data x0 / 484 /, y0 / 1 /, xb / 155 /, yb / 354 /
       data y5 / 170 /, y4 / 250 /, y3 / 8 /, y2 / 314 /
       data y6 /  65 /, y7 / 210 /, y8 / 274 /, y9 / 332 /
       data xyhi / 1 /
c
c
c         Initialize display.
c         -------------------
c
       if     (fnc .eq. 0) then
          call coolfr (x0, y0, x0 + xb, y0 + yb)
c
          call opqchr1 ('gate     v  amp',
     :                  x0 + 10, y0 + y2,      fontbuf (blk1))
c
          call opqchr1 ('pct      val',
     :                  x0 + 10, y0 + y3,      fontbuf (blk1))
          call opqchr1 ('bkg     span',
     :                  x0 + 10, y0 + y3 + 16, fontbuf (blk1))
c
          call opqchr1 ('st  0  fr   0/  0',
     :                  x0 + 10, y0 + y4,      fontbuf (blk1))
c
          call opqchr1 ('avf   0     bf  4',
     :                  x0 + 10, y0 + y5,      fontbuf (blk1))
          call opqchr1 ('avg   0     bg  4',
     :                  x0 + 10, y0 + y5 + 16, fontbuf (blk1))
c
          call opqchr1 (char (127),
     :                  x0 + 98, y0 + y6 - 16, fontbuf (blk1))
          call opqchr1 ('n   x     y     z',
     :                  x0 + 10, y0 + y6,      fontbuf (blk1))
          call opqchr1 ('1   0     0     0',
     :                  x0 + 10, y0 + y6 + 16, fontbuf (blk1))
          call opqchr1 ('2   0     0     0',
     :                  x0 + 10, y0 + y6 + 32, fontbuf (blk1))
          call opqchr1 ('3   0     0     0',
     :                  x0 + 10, y0 + y6 + 48, fontbuf (blk1))
          call opqchr1 ('4   0     0     0',
     :                  x0 + 10, y0 + y6 + 64, fontbuf (blk1))
          call opqchr1 ('5   0.0   0.0    ',
     :                  x0 + 10, y0 + y6 + 80, fontbuf (blk1))
c
          call opqchr1 ('tf 0.00  run 0.00',
     :                  x0 + 10, y0 + y7,      fontbuf (blk1))
          call opqchr1 ('tg 0.00  acq 0.00',
     :                  x0 + 10, y0 + y7 + 16, fontbuf (blk1))
c
          call opqchr1 ('Buf min, val, max',
     :                  x0 +  10, y0 + y8, fontbuf (blk1))
c
          call opqchr1 ('TEC      a      C',
     :                  x0 +  10, y0 + y9, fontbuf (blk1))
          call opqchr1 (char (248),
     :                  x0 + 130, y0 + y9, fontbuf (blk1))
c
c
c         TEC voltage.
c         ------------
c
       elseif (fnc .eq. 1) then
          r4 = r4val (arg)
          call fform (r4, newtec, 1, 1)
          call smalltext (newtec, oldtec,
     :                    x0 + 50, y0 + y9, fontbuf (blk1))
c
c
c         CCD Temperature.
c         ----------------
c
       elseif (fnc .eq. 2) then
          r4 = r4val (arg)
          call fform (r4, newtmp, 1, 1)
          call smalltext (newtmp, oldtmp,
     :                    x0 + 90, y0 + y9, fontbuf (blk1))
c
c
c         FIFO min.
c         ---------
c
       elseif (fnc .eq. 3) then
          i4 = i4val (arg)
          call iform (i4, newfmn, 1)
          call smalltext (newfmn, oldfmn,
     :                    x0 +  26, y0 + y8 + 16, fontbuf (blk1))
c
c
c         FIFO val.
c         ---------
c
       elseif (fnc .eq. 4) then
          i4 = i4val (arg)
          call iform (i4, newfvl, 1)
          call smalltext (newfvl, oldfvl,
     :                    x0 +  66, y0 + y8 + 16, fontbuf (blk1))
c
c
c         FIFO max.
c         ---------
c
       elseif (fnc .eq. 5) then
          i4 = i4val (arg)
          call iform (i4, newfmx, 1)
          call smalltext (newfmx, oldfmx,
     :                    x0 + 106, y0 + y8 + 16, fontbuf (blk1))
c
c
c         Exposure time -- full frame.
c         ----------------------------
c
       elseif (fnc .eq. 6) then
          r4 = r4val (arg)
          call fform (r4, newexf, 2, 1)
          call smalltext (newexf, oldexf,
     :                    x0 + 26,  y0 + y7,      fontbuf (blk1))
c
c
c         Exposure time -- subraster.
c         ---------------------------
c
       elseif (fnc .eq. 7) then
          r4 = r4val (arg)
          call fform (r4, newexs, 2, 1)
          call smalltext (newexs, oldexs,
     :                    x0 + 26, y0 + y7 + 16, fontbuf (blk1))
c
c
c         Running exposure time.
c         ----------------------
c
       elseif (fnc .eq. 8) then
          r4 = r4val (arg)
          call fform (r4, newrun, 2, 1)
          call smalltext (newrun, oldrun,
     :                    x0 + 106,  y0 + y7,    fontbuf (blk1))
c
c
c         Acquisition time.
c         -----------------
c
       elseif (fnc .eq. 9) then
          r4 = r4val (arg)
          call fform (r4, newacq, 2, 1)
          call smalltext (newacq, oldacq,
     :                    x0 + 106, y0 + y7 + 16, fontbuf (blk1))
c
c
c         Highlight cursor number.
c            fnc = 11... 15
c         ------------------------
c
       elseif ((11 .le. fnc) .and. (fnc .le. 15)) then
          call opqchr1 (char (48 + xyhi), x0 + 10,
     :       y0 + y6 + (16 * xyhi), fontbuf (blk1))
          xyhi = fnc - 10
          call opqchr1 (char (48 + xyhi), x0 + 10,
     :       y0 + y6 + (16 * xyhi), fontbuf (grn1))
c
c
c         X-cursor position.
c         fnc = 21... 24, 25
c         ------------------
c
       elseif ((21 .le. fnc) .and. (fnc .le. 24)) then
          i4 = i4val (arg) / 10
          call iform (i4, chr3, 1)
          i4 = fnc - 20
          call opqchr1 (chr3, x0 + 26,
     :       y0 + y6 + (16 * i4), fontbuf (blk1))
c
       elseif (fnc .eq. 25) then
          r4 = i4val (arg) / 10.
          call fform (r4, chr5, 1, 1)
          call opqchr1 (chr5, x0 + 26, y0 + y6 + 80, fontbuf (blk1))
c
c
c         Y-cursor position.
c         fnc = 31... 34, 35
c         ------------------
       elseif ((31 .le. fnc) .and. (fnc .le. 34)) then
          i4 = i4val (arg) / 10
          call iform (i4, chr3, 1)
          i4 = fnc - 30
          call opqchr1 (chr3, x0 + 74,
     :       y0 + y6 + (16 * i4), fontbuf (blk1))
c
       elseif (fnc .eq. 35) then
          r4 = i4val (arg) / 10.
          call fform (r4, chr5, 1, 1)
          call opqchr1 (chr5, x0 + 74, y0 + y6 + 80, fontbuf (blk1))
c
c
c         Z-cursor value.
c            fnc = 41... 44
c         -----------------
c
       elseif ((41 .le. fnc) .and. (fnc .le. 44)) then
          i4 = fnc - 40
          call iform (i4val (arg), newzcr (i4), 1)
          call smalltext (newzcr (i4), oldzcr (i4), x0 + 106,
     :       y0 + y6 + (16 * i4), fontbuf (blk1))

c
c
c         Cursor delta.
c         -------------
c
       elseif (fnc .eq. 51) then
          r4 = i4val (arg) / 10.
          call fform (r4, chr4, 1, 1)
          call opqchr1 (chr4, x0 + 114,
     :                 y0 + y6 - 16, fontbuf (blk1))
c
c
c         Averaging parameter -- full frame.
c         ----------------------------------
c
       elseif (fnc .eq. 53) then
          i4 = i4val (arg)
          call iform (i4, chr3, 1)
          call opqchr1 (chr3, x0 + 42,
     :                  y0 + y5,      fontbuf (blk1))
c
c
c         Averaging parameter -- subraster.
c         ---------------------------------
c
       elseif (fnc .eq. 54) then
          i4 = i4val (arg)
          call iform (i4, chr3, 1)
          call opqchr1 (chr3, x0 + 42,
     :                  y0 + y5 + 16, fontbuf (blk1))
c
c
c         Pixel binning -- full frame.
c         ----------------------------
c
       elseif (fnc .eq. 55) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 130,
     :                  y0 + y5,      fontbuf (blk1))
c
c
c         Pixel binning -- subraster.
c         ---------------------------
c
       elseif (fnc .eq. 56) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 130,
     :                  y0 + y5 + 16, fontbuf (blk1))
c
c
c         Percentile value.
c         -----------------
c
       elseif (fnc .eq. 57) then
          i4 = i4val (arg)
          call iform (i4, newval, 1)
          call smalltext (newval, oldval,
     :                    x0 + 106, y0 + y3, fontbuf (blk1))
c
c
c         Send-frame number.
c         ------------------
c
       elseif (fnc .eq. 58) then
          i4 = i4val (arg)
          call iform (i4, newfrm, 1)
          call smalltext (newfrm, oldfrm,
     :                    x0 + 82, y0 + y4, fontbuf (blk1))
c
c
c         Send-frame rows.
c         ----------------
c
       elseif (fnc .eq. 59) then
          i4 = i4val (arg)
          call iform (i4, newrow, 1)
          call smalltext (newrow, oldrow,
     :                    x0 + 122, y0 + y4, fontbuf (blk1))
c
c
c         Send-frame time.
c         ----------------
c
       elseif (fnc .eq. 60) then
          i4 = i4val (arg)
          call iform (i4, newsdt, 1)
          call smalltext (newsdt, oldsdt,
     :                    x0 + 26, y0 + y4, fontbuf (blk1))
c
c
c         Percentile setting.
c         -------------------
c
       elseif (fnc .eq. 61) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 42, y0 + y3, fontbuf (blk1))
c
c
c         Screen intensity.
c         -----------------
c
       elseif (fnc .eq. 62) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 42, y0 + y3 + 16, fontbuf (blk1))
c
c
c         Span.
c         -----
c
       elseif (fnc .eq. 63) then
          i4 = i4val (arg)
          call iform (i4, chr5, 1)
          call opqchr1 (chr5, x0 + 106, y0 + y3 + 16, fontbuf (blk1))
c
c
c         Amplifier.
c         ----------
c
       elseif (fnc .eq. 64) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 130, y0 + y2, fontbuf (blk1))
c
c
c         Output gate voltage.
c         --------------------
c
       elseif (fnc .eq. 65) then
          r4 = r4val (arg)
          call fform (r4, chr4, 1, 1)
          call opqchr1 (chr4, x0 + 50, y0 + y2, fontbuf (blk1))
c
c
c         SH.
c         ----------
c
       elseif (fnc .eq. 66) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          if (i4 .eq. 0) then
              call opqchr1 ('fr', x0 + 66, y0 + y4, fontbuf (blk1))
          else
              call opqchr1 ('fr', x0 + 66, y0 + y4, fontbuf (grn1))
          endif
c
       endif
c
       return
       end
