c
c
c         prompt display box
c         ------------------
c
       subroutine pbox (fnc, arg)
c
       implicit  none
c
       integer*4 fnc, i4val, iscrl, nscrl
       integer*4 x0, y0, xb, yb, iy, iline
       integer*4 y1, y2, y3, y4, y5, nb
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       integer*1 ib24 (24)
       character newav*2, oldav*2, newmx*3, oldmx*3
       character arg*(*), cb24*24, scroll*24 (4)
c
       equivalence (ib24, cb24)
c
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
c
       data x0 / 0 /, y0 / 358 /, xb / 213 /, yb / 121 /
       data y1 / 82 /, y2 / 98 /, y3 / 58 /, y4 / 10 /, y5 / 74 /
       data iline / 4 /, nscrl / 0 /
       data ib24 / 24 * 32 /
c
c
c         Initialize.
c         -----------
c
       if     (fnc .eq. 0) then
          call coolfr (x0, y0, x0 + xb, y0 + yb)
          call opqchr1 ('Input--',
     :                  x0 + 12,  y0 + y4, fontbuf (blk1))
          call opqchr1 ('ms:   av    mx',
     :                  x0 + 92, y0 + y4, fontbuf (blk1))
c
c
c         Clear the entry line.
c         ---------------------
c
       elseif (fnc .eq. 1) then
          call opqchr1 (cb24, x0 + 12, y0 + y2, fontbuf (blk1))
          call opqchr1 (arg,  x0 + 12, y0 + y2, fontbuf (blk1))
c
c
c         Put one character onto the entry line.
c         --------------------------------------
c
       elseif ((fnc .gt. 100) .and. (fnc .lt. 124)) then
          call opqchr1 (arg  (1:1), x0 + 20 + (8 * (fnc - 100)),
     :                              y0 + y2, fontbuf (blk1))
c
c
c         Push a line onto the bottom
c         of the scrolled region.
c         ---------------------------
c
       elseif (fnc .eq. 2) then
          nscrl = nscrl + 1
          if (nscrl .gt. 4) nscrl = 1
          call memcpy (scroll (nscrl), cb24, 24)
          nb = min (len (arg), 24)
          call memcpy (scroll (nscrl), arg,  nb)
          iline = 0
c
c
c         Average cycle time.
c         -------------------
c
       elseif (fnc .eq. 3) then
          call iform (i4val (arg), newav, 1)
          call smalltext (newav, oldav,
     :                    x0 +  116, y0 + y4, fontbuf (blk1))
c
c
c         Max cycle time.
c         ---------------
c
       elseif (fnc .eq. 4) then
          call iform (i4val (arg), newmx, 1)
          call smalltext (newmx, oldmx,
     :                    x0 + 156, y0 + y4, fontbuf (blk1))
c
c
c         Update scrolled display.
c         ------------------------
c
       elseif (fnc .eq. 5) then
          if (iline .lt. 4) then
             iline = iline + 1
             iscrl = nscrl + iline
             if (iscrl .gt. 4) iscrl = iscrl - 4
             iy = y0 + 18 + (16 * iline)
             call opqchr1 (scroll (iscrl),
     :                     x0 + 12, iy, fontbuf (blk1))
          endif
c
       endif
c
       return
       end
c
c
c         Message display box.
c
c               fnc       disp
c            --------   ------------------
c             0         init
c             1... 10   line  1... 10, wht
c            11... 20   line 11... 20, blk
c            21         line numbers
c            22         scroll flag
c            23         time-of-day
c            24         elapsed time
c
c         If the message number is followed
c         by a ':', display a red LED.  If
c         the message number is folowed by
c         a ';', display a green LED.
c         ---------------------------------
c
       subroutine mbox (fnc, arg)
c
       implicit  none
c
       real*8    r8val, mjd
       real*4    r4val
       integer*4 fnc, i4val, errno, ios
       integer*4 x0, y0, xb, yb, y1, y2, iy
       integer*4 hrs, min, sec
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       character newut*8, oldut*8, newet*6, oldet*6
       character arg*(*), chr3*3
c
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
c
       data x0 / 216 /, y0 / 358 /, xb / 423 /, yb / 121 /
       data y1 /  10 /, y2 / 18 /, newut / '        ' /
c
       if     (fnc .eq.  0) then
          call coolfr (x0, y0, x0 + xb, y0 + yb)
          call opqchr1 ('System Messages    -      et:      d  UT:',
     :                   x0 + 12, y0 + y1, fontbuf (blk1))
          go to 990
c
       elseif (fnc .le. 10) then
          iy  = y0 + y2 + (16 * (fnc))
          call opqchr1 (arg (1:50), x0 + 12, iy, fontbuf (wht1))
c
       elseif (fnc .le. 20) then
          iy  = y0 + y2 + (16 * (fnc - 10))
          call opqchr1 (arg (1:50), x0 + 12, iy, fontbuf (blk1))
       endif
c
       if     (fnc .eq. 21) then
          call iform (i4val (arg), chr3, 3)
          call opqchr1 (chr3, x0 + 140, y0 + y1, fontbuf (blk1))
c
       elseif (fnc .eq. 22) then
          call iform (i4val (arg), chr3, 3)
          call opqchr1 (chr3, x0 + 172, y0 + y1, fontbuf (blk1))
c
       elseif (fnc .eq. 23) then
          mjd = r8val (arg)
          hrs = int (mjd)
          mjd = 24.d0 * (mjd - hrs)
          hrs = int (mjd)
          mjd = 60.d0 * (mjd - hrs)
          min = int (mjd)
          mjd = 60.d0 * (mjd - min)
          sec = int (mjd)
c
          call iform (hrs, newut (1:2), 2)
          call iform (min, newut (4:5), 2)
          call iform (sec, newut (7:8), 2)
          call smalltext (newut,  oldut,
     :                    x0 + 348, y0 + y1, fontbuf (blk1))
c
       elseif (fnc .eq. 24) then
          call fform (r4val (arg), newet, 2, 1)
          call smalltext (newet, oldet,
     :                    x0 + 244, y0 + y1, fontbuf (blk1))
c
       elseif (arg (17:17) .eq. ':') then
          call opqchr1 (char (254), x0 + 141, iy, fontbuf (red1))
       elseif (arg (17:17) .eq. ';') then
          call opqchr1 (char (254), x0 + 141, iy, fontbuf (grn1))
       endif
c
  990  continue
       return
       end
c