c
c
c         FORTRAN entry for clock service
c         routine -- guider camera.
c         -------------------------------
c
       subroutine clock2
c
       implicit  none
c
       real*8    utime, tzero, tstep, tzset, tsset
       integer*4 mjday, clkct, savct, i4
       integer*4 i, ictr, peek, clkerr
       integer*4 timer1, timer2, timer3, timer4
       logical*4 setfl
c
       common / clkcom / utime, mjday
       common / clkvar / tzset, tsset, setfl, savct
       common / timcom / timer1, timer2, timer3, timer4
c
c
c         If the set flag is true, set
c         the clock.  Then, update the
c         time.
c         ----------------------------
c
       if (setfl) then
          setfl = .false.
          tzero = tzset
          tstep = tsset
          savct = clkct
          clkct = 0
       endif
c
       clkct  = clkct + 1
       utime  = tzero + (clkct * tstep)
       if (utime .ge. 1.d0) then
           mjday = mjday + 1
           utime = 0.d0
           tzero = 0.d0
           savct = clkct
           clkct = 0
       endif
c
c
c         Update timers for main program.
c         The allocation of timers is CRITICAL:
c            timer1: Counts up to 1 000 000 000
c                    clock ticks, then resets
c            timer2: Cycle counter for timer1
c            timer3:
c            timer4: Watchdog timer
c         -------------------------------
c
       timer1 = timer1 + 1
       if (timer1 .gt. 1000000000) then
          timer1 = 0
          timer2 = timer2 + 1
       endif
       timer3 = timer3 + 1
       if (timer3 .gt. 10000) timer3 = 0
c
c
c         Timer4 is set to zero every time the foreground
c         program completes a loop.  Address the watchdog
c         timer whenever timer4 is zero.  This way, both
c         the foreground AND background tasks must be
c         running in order to keep the watchdog timer going.
c         --------------------------------------------------
c
       if (timer4 .eq. 0)     then
ccc          call outp (x'247', x'FF')
          timer4 = 1
       endif
c
       if (timer4 .lt. 10000) then
          timer4 = timer4 + 1
       endif
c
c
c         Check the DSP.
c         --------------
c
       call dspchk
c
c
c         Check the serial ports.
c         -----------------------
c
       call serchk1
c
c
c         Call the BIOS time-of-day clock.  Do this only
c         once for every 32 times the clock interrupt
c         occurs.  The other 31 times, just issue an end-
c         of-interrupt command to the interrupt controller.
c         -------------------------------------------------
c
       if (ictr .ge. 32) then
          ictr = 1
          call int162
       else
          ictr = ictr + 1
          call outp (x'20', x'20')
       endif
c
       return
       end
c
c
c         Put a message into the clock error log.
c         ---------------------------------------
c
       integer*4 function clkerr (msg)
c
       implicit  none
c
       integer*4 nch, clkptr
c
       character*40 clkmsg (100), blank
       character    msg*(*)
c
       common / clklog / clkptr, clkmsg
c
       data clkptr / 0 /
       data blank
     :  / '                                        ' /
c
c
c         Transfer the message,
c         up to 37 chars.
c         ---------------------
c
       clkptr = clkptr + 1
       if (clkptr .gt. 100) clkptr = 1
       clkmsg (clkptr) = blank
       nch = min (len (msg), 37)
       if (nch .gt. 0) clkmsg (clkptr) (1:nch) = msg (1:nch)
c
       clkerr = clkptr
       return
       end
c