c
c
c         Serial port driver for connection
c         to Magellan TCS computer.
c         ----------------------------------
c
       subroutine serchk1
c
       implicit  none
c
       real*8    utime, errtm
       integer*4 mjday, seradr, step, i
       integer*4 sndbuf (100), rcvbuf (100)
       integer*4 nsnd, nrcv, isnd, ircv
       integer*4 istat, inp, errfl
       logical*4 ok
c
       common / clkcom / utime, mjday
       common / sr1com / errtm, errfl, nsnd,
     :                   nrcv, sndbuf, rcvbuf
c
       data seradr / x'2F8' /, step / 0 /
c
c
c         On first entry or after an error has
c         occurred, perform the standard
c         serial port initialization sequence.
c         Use 38,400 baud, 7 data bits, 1 stop
c         bit, odd parity.
c         ------------------------------------
c
       if (step .eq. 0) then
          call outp (seradr + 3, x'8A')
          call outp (seradr,     x'03')
          call outp (seradr + 1, x'00')
          call outp (seradr + 3, x'0A')
          call outp (seradr + 2, x'C7')
          call outp (seradr + 4, x'03')
          step = 1
c
c
c         Wait for a foreground i/o request.
c         ----------------------------------
c
       elseif (step .eq. 1) then
          if (errfl .ge. 0) go to 990
c
c
c         Make sure the transmit and receive FIFO's
c         are empty.  Otherwise, flag an error.
c         -----------------------------------------
c
          istat = inp (seradr + 5)
          if     (and (istat, x'0040') .eq. 0) then
             errtm = utime
             errfl = 1
             step  = 0
c
          elseif (and (istat, x'0001') .eq. 1) then
	     istat = inp (seradr)
             errtm = utime
             errfl = 2
             step  = 0
c
          else
             isnd = 0
             step = 2
          endif
       endif
c
c
c         Send the data to be transmitted.
c         This may take several clock cycles.
c         Wait for the FIFO to be empty, and
c         then transmit up to 16 bytes.
c         -----------------------------------
c
       if (step .eq. 2) then
          istat = inp (seradr + 5)
          if (and (istat, x'0040') .ne. 0) then
             do 120 i = 1, 16
                isnd = isnd + 1
                call outp (seradr, sndbuf (isnd))
                if (isnd .ge. nsnd) then
                   ok = .true.
                   ircv = 0
                   step = 3
                   go to 990
                endif
  120        continue
          endif
c
c
c         Check for timeout.
c         ------------------
c
          errfl = errfl + 1
          if (errfl .ge. 0) then
             errtm = utime
             errfl = 3
             step  = 0
          endif
c
c
c         Read back the reply.  Check
c         for an error in serial line.
c         ----------------------------
c
       elseif (step .eq. 3) then
  220     continue
          istat = inp (seradr + 5)
          ok = ok .and. (and (istat, x'001E') .eq. 0)
          if (and (istat, x'0001') .eq. 1) then
             ircv = ircv + 1
             if (ircv .le. 100) then
                rcvbuf (ircv) = inp (seradr)
                go to 220
c
c
c         Receive buffer overflow.
c         ------------------------
c
             else
                errtm = utime
                errfl = 4
                step  = 0
             endif
c
c
c         No character in the receive buffer.
c         Check if done (last character = <cr>).
c         --------------------------------------
c
          else
             if (ircv .ge. 1) then
                if (rcvbuf (ircv) .eq. 13) then
                   if (ok) then
                      errtm = utime
                      errfl = 0
                      step  = 1
                   else
                      errtm = utime
                      errfl = 5
                      step  = 0
                   endif
                   nrcv = ircv
                   go to 990
                endif
             endif
c
c
c         Check for timeout.
c         ------------------
c
             errfl = errfl + 1
             if (errfl .ge. 0) then
                errtm = utime
                errfl = 7
                step  = 0
             endif
c
          endif
c
       endif
c
  990  continue
       return
       end
