c
c
c         Accept commands for Magellan
c         telescope control program.
c         ----------------------------
c
       integer*4  function cmd (alph, num, r4, negflag, c24)
c
       implicit   none
c
       real*4     r4 (3)
       integer*4  num, ia, nkey, ikey, nstrt, ier
       logical*4  negflag
       character  c24*(*)
c
       integer*2  key (23), inkey$, keyval
       character  alph*8, numph*25
c
       data  nkey / 0 /, key / 23 * 0 /
c
c
c         emit prompt
c         -----------
c
       if (nkey .lt. 1) then
          call pbox (1, '* _')
          nkey = 1
       endif
c
c
c         accept command characters
c         -------------------------
c
       cmd = 0
c
  220  continue
       keyval = inkey$ ()
       if (keyval .eq. 0)  go to 600
       if (keyval .eq. 13) go to 300
c
c
c         Check for special function keys.  Return a
c         blank command string, or else the previous
c         command might be parsed.
c         ------------------------------------------
c
       if ((keyval .eq. 27)                            .or.
     :     (( -73 .le. keyval) .and. (keyval .le.  -71)) .or.
     :     (( -83 .le. keyval) .and. (keyval .le.  -75)) .or.
     :     (( -68 .le. keyval) .and. (keyval .le.  -59)) .or.
     :     ((-119 .le. keyval) .and. (keyval .le. -117)) .or.
     :     ((-134 .le. keyval) .and. (keyval .le. -132)) .or.
     :     (keyval .eq. -141) .or. (keyval .eq. -145)         ) then
          alph = '    '
          cmd = keyval
          go to 600
       endif
c
c
c         Check for regular keys.
c         ----------------------
c
       if ( ((keyval .gt. 47) .and. (keyval .lt.  58)) .or.
     :      ((keyval .gt. 64) .and. (keyval .lt.  91)) .or.
     :      ((keyval .gt. 96) .and. (keyval .lt. 123)) .or.
     :      (keyval .eq. 32)  .or. (keyval .eq.  45)   .or.
     :      (keyval .eq. 46)                                ) then
c
          key (nkey) = keyval
          if (nkey .ge. 23) then
             nkey = 22
             key (22) = key (23)
          endif
c
          call pbox (100 + nkey, char (key (nkey)))
          nkey = nkey + 1
          if (nkey .le. 22) then
             call pbox (100 + nkey, '_')
          endif
c
c
c         Backspace
c         ---------
c
       elseif ((keyval .eq. 8) .and. (nkey .gt. 1)) then
          if (nkey .le. 22) then
             call pbox (100 + nkey, ' ')
          endif
          nkey = nkey - 1
          call pbox (100 + nkey, '_')
c
       endif
       go to 220
c
c
c         process command - first, clear
c         alpha and numeric command buffers
c         ---------------------------------
c
  300  continue
       nkey = nkey - 1
       num = 0
       alph = '    '
       ia = 1
c
c
c         now parse
c         ---------
c
       c24 = '*                       '
       nkey = min (nkey, 22)
       if (nkey .gt. 0) then
          do 320 ikey = 3, nkey + 2
             c24 (ikey:ikey) = char (key (ikey - 2))
  320     continue
       endif
       call pbox (2, c24)
       if (nkey .lt. 1) go to 600
       call puteds (2, '810;'//c24(1:24)//'         ')
c
c
c         drop leading blanks
c         -------------------
c
       ikey = 1
  330  continue
       if (key (ikey) .eq. 32) then
          ikey = ikey + 1
          if (ikey .lt. nkey) go to 330
       endif
c
c
c         read the alpha field
c         --------------------
c
  340  continue
       if ((key (ikey) .gt. 64) .and. (key (ikey) .lt. 91))
     :    key (ikey) = key (ikey) + 32
       alph (ia:ia) = char (key (ikey))
       ikey = ikey + 1
       if (ikey .gt. nkey) go to 540
       if  (key (ikey) .eq. 32) go to 350
       if  (key (ikey) .eq. 45) go to 350
       if ((key (ikey) .gt. 47) .and. (key (ikey) .lt. 58)) go to 350
       if (ia .lt. 8) then
          ia = ia + 1
          go to 340
       else
          call pbox (2, '  alpha command overflow')
          nkey = 0
          go to 600
       endif
  350  continue
c
c
c         Read the numeric fields -- first, drop blanks.
c         Watch for a minus sign in any number.
c         ----------------------------------------------
c
       negflag = .false.
  360  continue
       if (key (ikey) .eq. 32) then
          ikey = ikey + 1
          if (ikey .le. nkey) go to 360
       endif
       if (ikey .gt. nkey) go to 540
c
       ia = 1
  370  continue
       numph (ia:ia) = char (key (ikey))
       ikey = ikey + 1
       if ((key (ikey) .ne. 32) .and. (ikey .le. nkey)) then
          ia = ia + 1
          go to 370
       else
          if (num .lt. 3) then
             num = num + 1
             if (numph (1:1) .eq. '-') negflag = .true.
             nstrt = 1
             call sla_flotin (numph (1:ia), nstrt, r4 (num), ier)
             if (ier .ge. 1) go to 380
          else
             call pbox (2, 'numeric command overflow')
             nkey = 0
             go to 600
          endif
       endif
c
       if (ikey .le. nkey) then
          go to 360
       else
          go to 540
       endif
c
  380  continue
       call pbox (2, '  numeric decode error')
       nkey = 0
       go to 600
c
  540  continue
       nkey = 0
c      if ((num .gt. 0) .and. negflag) then
c         do 560 ikey = 1, num
c            if (r4 (ikey) .gt. 0.) r4 (ikey) = - r4 (ikey)
c 560     continue
c      endif
       cmd = 1
c
  600  continue
       return
       end
c
c
c
c         Accept commands for Magellan
c         telescope control program.
c         from the network
c         ----------------------------
c
       logical*4  function netcmd (netkey, cmd, alph, num, r4,
     : negflag, pbxmsg, c24)
c
       implicit   none
c
       real*4     r4 (3)
       integer*4  num, ia, nkey, ikey, nstrt, ier
       integer*4  cmd
       logical*4  negflag
       character  c24*(*)
c
       integer*2  key (23), netkey, keyval
       character  alph*8, numph*25, pbxmsg*24
c
       data  nkey / 0 /, key / 23 * 0 /

        netcmd = .true.
c
c
c         don't emit prompt
c         -----------
c
       if (nkey .lt. 1) then
          nkey = 1
       endif
c
c
c         accept command characters
c         -------------------------
c
       cmd = 0
c
  220  continue
       keyval = netkey
       if (keyval .eq. 0)  go to 600
       if (keyval .eq. 13) go to 300
c
c
c         Check for special function keys.  Return a
c         blank command string, or else the previous
c         command might be parsed.
c         ------------------------------------------
c
       if ((keyval .eq. 27)                            .or.
     :     (( -73 .le. keyval) .and. (keyval .le.  -71)) .or.
     :     (( -83 .le. keyval) .and. (keyval .le.  -75)) .or.
     :     (( -68 .le. keyval) .and. (keyval .le.  -59)) .or.
     :     ((-119 .le. keyval) .and. (keyval .le. -117)) .or.
     :     ((-134 .le. keyval) .and. (keyval .le. -132)) .or.
     :     (keyval .eq. -141) .or. (keyval .eq. -145)         ) then
          alph = '    '
          cmd = keyval
          go to 600
       endif
c
c
c         Check for regular keys.
c         ----------------------
c
       if ( ((keyval .gt. 47) .and. (keyval .lt.  58)) .or.
     :      ((keyval .gt. 64) .and. (keyval .lt.  91)) .or.
     :      ((keyval .gt. 96) .and. (keyval .lt. 123)) .or.
     :      (keyval .eq. 32)  .or. (keyval .eq.  45)   .or.
     :      (keyval .eq. 46)                                ) then
c
          key (nkey) = keyval
          if (nkey .ge. 23) then
             nkey = 22
             key (22) = key (23)
          endif
c
          nkey = nkey + 1
c
c
c         Backspace
c         ---------
c
       elseif ((keyval .eq. 8) .and. (nkey .gt. 1)) then
          nkey = nkey - 1
c
       endif
       go to 600
c
c
c         process command - first, clear
c         alpha and numeric command buffers
c         ---------------------------------
c
  300  continue
       nkey = nkey - 1
       num = 0
       alph = '    '
       ia = 1
c
c
c         now parse
c         ---------
c
       c24 = '*                       '
       nkey = min (nkey, 22)
       if (nkey .gt. 0) then
          do 320 ikey = 3, nkey + 2
             c24 (ikey:ikey) = char (key (ikey - 2))
  320     continue
       endif
       if (nkey .lt. 1) go to 600
       call puteds (2, '811;'//c24(1:24)//'         ')
c
c
c         drop leading blanks
c         -------------------
c
       ikey = 1
  330  continue
       if (key (ikey) .eq. 32) then
          ikey = ikey + 1
          if (ikey .lt. nkey) go to 330
       endif
c
c
c         read the alpha field
c         --------------------
c
  340  continue
       if ((key (ikey) .gt. 64) .and. (key (ikey) .lt. 91))
     :    key (ikey) = key (ikey) + 32
       alph (ia:ia) = char (key (ikey))
       ikey = ikey + 1
       if (ikey .gt. nkey) go to 540
       if  (key (ikey) .eq. 32) go to 350
       if  (key (ikey) .eq. 45) go to 350
       if ((key (ikey) .gt. 47) .and. (key (ikey) .lt. 58)) go to 350
       if (ia .lt. 8) then
          ia = ia + 1
          go to 340
       else
          pbxmsg = '  alpha command overflow'
          netcmd = .false.
          nkey = 0
          go to 600
       endif
  350  continue
c
c
c         Read the numeric fields -- first, drop blanks.
c         Watch for a minus sign in any number.
c         ----------------------------------------------
c
       negflag = .false.
  360  continue
       if (key (ikey) .eq. 32) then
          ikey = ikey + 1
          if (ikey .le. nkey) go to 360
       endif
       if (ikey .gt. nkey) go to 540
c
       ia = 1
  370  continue
       numph (ia:ia) = char (key (ikey))
       ikey = ikey + 1
       if ((key (ikey) .ne. 32) .and. (ikey .le. nkey)) then
          ia = ia + 1
          go to 370
       else
          if (num .lt. 3) then
             num = num + 1
             if (numph (1:1) .eq. '-') negflag = .true.
             nstrt = 1
             call sla_flotin (numph (1:ia), nstrt, r4 (num), ier)
             if (ier .ge. 1) go to 380
          else
             pbxmsg = 'numeric command overflow'
             netcmd = .false.
             nkey = 0
             go to 600
          endif
       endif
c
       if (ikey .le. nkey) then
          go to 360
       else
          go to 540
       endif
c
  380  continue
       pbxmsg = '  numeric decode error'
       netcmd = .false.
       nkey = 0
       go to 600
c
  540  continue
       nkey = 0
c      if ((num .gt. 0) .and. negflag) then
c         do 560 ikey = 1, num
c            if (r4 (ikey) .gt. 0.) r4 (ikey) = - r4 (ikey)
c 560     continue
c      endif
       cmd = 1
c
  600  continue
       return
       end
c
