c
c
c         Foreground part of DSP management
c         routine for Magellan guider camera.
c         -----------------------------------
c
       subroutine dsprun
c
       implicit  none
c
       real*4    r4
       integer*4 dspini, dsperr, dt, step
       integer*4 dspflg (47), dspval (47)
       integer*4 iobase, pt1map, pt2map, mpeek
       integer*4 tmperr, tmpval, vbsval, i, i4
       integer*4 fifmin, fifval, fifmax, ft0, ft1
       integer*4 timer1, timer2, timer3, timer4
       integer*4 exptim, runtim, acqtim, errct
       integer*4 imgsiz, imgptr, imgflg
       integer*4 imgbuf (300000)
       character msg*37
c
       common / pcicom / iobase, pt1map, pt2map
       common / dspcom / dspini, dsperr, dspflg, dspval
       common / tmpcom / tmperr, tmpval, vbsval
       common / fifcom / fifmin, fifval, fifmax
       common / timcom / timer1, timer2, timer3, timer4
       common / imgcom / imgsiz, imgptr, imgflg, imgbuf
       common / expcom / exptim, runtim, acqtim
c
       data tmperr / -1 /, step / 1 /, errct / 0 /
c
c
c         DSP FIFO error.  Try to fix it.
c         -------------------------------
c
       if     (dspini .eq. 3) then
          msg = '022: DSP FIFO error, code = xxxx'
          call iform (dsperr, msg (29:32), 1)
          call putmsg (msg)
          msg = '023: Initial FIFO count =xxxxx'
          call iform (fifval, msg (26:30), 1)
          call putmsg (msg)
c
          if ((0 .lt. fifval) .and. (fifval .lt. 99999)) then
             do 100 i = 1, fifval
                i4 = mpeek (pt1map)
  100        continue
c
             fifval = mpeek (pt2map)
             msg = '024:   Final FIFO count =xxxxx'
             call iform (fifval, msg (26:30), 1)
             call putmsg (msg)
c
             if (fifval .eq. 0) then
                dspini = 2
             else
                dspini = 0
             endif
c
          else
             dspini = 0
c
          endif
c
c
c         DSP read-back time-out.
c         -----------------------
c
       elseif (dspini .eq. 4) then
          msg = '029: DSP read-back error, item = xxxx'
          call iform (dsperr, msg (34:37), 1)
          call putmsg (msg)
          dspini = 0
c
c
c         FIFO counter sync error.
c         This requires a reset.
c         ------------------------
c
       elseif (dspini .eq. 6) then
          call putmsg ('028: DSP FIFO Counter sync error')
          dspini = 1
c
c
c         DSP data time-out error.  This happens
c         when there is a data underrun.  Give
c         up and start a new frame.
c         ---------------------------------------
c
       elseif (dspini .eq. 7) then
          if (errct .le. 3) then
             msg = '025: DSP time-out, xxxxxx words to go'
             call iform (dsperr, msg (20:25), 1)
             call putmsg (msg)
             errct = errct + 1
             dspini = 2
          else
             call putmsg ('027: DSP error count exceeded')
             dspini = 1
          endif
c
c
c         DSP read-back error.
c         --------------------
c
       elseif (dspini .eq. 5) then
          msg = '026: DSP read-back error, code = xxxx'
          call iform (dsperr, msg (34:37), 1)
          call putmsg (msg)
          dspini = 0
c
       endif
c
c
c         Report the FIFO status and
c         the running exposure time.
c         --------------------------
c
       dt = timer1 - ft0
       if (dt .lt. 0) dt = dt + 1000000000
       if (dt .gt. 3000) then
          call vbox (3, fifmin)
          fifmin = 100000
          call vbox (5, fifmax)
          fifmax = 0
          ft0 = timer1
       endif
c
       dt = timer1 - ft1
       if (dt .lt. 0) dt = dt + 1000000000
       if (dt .gt. 60) then
          call vbox (4, fifval)
          ft1 = timer1
          r4 = runtim * .0017165
          call vbox (8, r4)
       endif
c
c
c         Report temperature readings.
c         ----------------------------
c
       if (tmperr .eq. 0) then
          r4 = (305.176e-6 * tmpval) - 2.5
          r4 = - (2.0 * r4) - (5.0e-3 * (vbsval - 4096))
          r4 = - 273. - (100. * r4)
          call vbox (2, r4)
          tmperr = - 1
c
       elseif (tmperr .gt. 0) then
          msg = '021: Tmp. query error code xxxx'
          call iform (tmperr, msg (28:31), 1)
          call putmsg (msg)
          tmperr = -1
       endif
c
c
c         Report the acquisition time.  Turn
c         off the one's bit of IMGFLG until
c         the next frame is completed.
c         ----------------------------------
c
       if (and (imgflg, 1) .eq. 1) then
          r4 = acqtim * .0017165
          call vbox (9, r4)
          imgflg = and (imgflg, x'FFFE')
          errct = 0
       endif
c
       return
       end
