c
c
c         Put Magellan guider camera data into
c         the Engineering Data Stream.
c         Each entry is terminated by a NUL
c         (integer value 0) character.
c         -----------------------------------
c
       subroutine puteds (fnc, arg)
c
       implicit  none
c
       real*8    utime, mjd
       integer*4 fnc, i, j, i4
       integer*4 hmsf (4), mjday
       integer*4 edsptr, tcsptr
       character*80 edsmsg (100)
       character csgn*1, arg*(*)
c
       common / edscom / edsptr, tcsptr, edsmsg
       common / clkcom / utime, mjday
c
       data edsptr / 0 /, tcsptr / 0 /
c
c
c         Advance the EDS pointer.  If the TCS link
c         goes down and more than 100 messages
c         accumulate, then the new EDS message will
c         write over one which was never transmitted
c         to the TCS.  To prevent this, advance the
c         TCS pointer if the EDS pointer catches up
c         to it.
c         ------------------------------------------
c
       edsptr = edsptr + 1
       if (edsptr .gt. 100) then
          edsptr = 1
          if (tcsptr .eq. 0) tcsptr = 2
       endif
c
       if (edsptr .eq. tcsptr) then
          tcsptr = tcsptr + 1
          if (tcsptr .gt. 100) tcsptr = 1
       endif
c
c
c         System messages.  Use
c         the original time stamp.
c         ------------------------
c
       if     (fnc .eq. 1) then
          edsmsg (edsptr) (1:2) = arg ( 1: 2)
          edsmsg (edsptr) (3:4) = arg ( 4: 5)
          edsmsg (edsptr) (5:6) = arg ( 7: 8)
          edsmsg (edsptr) (7:8) = arg (10:11)
          call memcpy (edsmsg (edsptr) (9:9), arg (14:14), 37)
       else
c
c         Time stamp.
c         -----------
c
          mjd = utime
          call sla_dd2tf (2, mjd, csgn, hmsf)
          call iform (hmsf (1), edsmsg (edsptr) (1:2), 2)
          call iform (hmsf (2), edsmsg (edsptr) (3:4), 2)
          call iform (hmsf (3), edsmsg (edsptr) (5:6), 2)
          call iform (hmsf (4), edsmsg (edsptr) (7:8), 2)
          call memcpy (edsmsg (edsptr) (9:9), arg (1:1), 37)
       endif
c
       edsmsg (edsptr) (46:46) = char (0)
c
       return
       end
c
