c
c
c         Draw a cool windows-like panel.
c         ulx, uly = screen coordinates of
c            upper-left corner.
c         lrx, lry = screen coordinates of
c            lower-right corner.
c         --------------------------------
c
       subroutine coolfr (ulx, uly, lrx, lry)
c
       implicit none
c
       integer*4 ulx, uly, lrx, lry, nx, iy
       integer*1 lo (1024), mid (1024), hi (1024)
c
       common / frmcom / lo, mid, hi
c
       nx = lrx - ulx + 1
       do 120 iy = 1, 4
          call opqwrt (hi,      iy,          ulx, lry - iy + 1)
          call opqwrt (lo, nx - iy,     ulx + iy, lry - iy + 1)
          call opqwrt (hi, nx - iy,          ulx, uly + iy - 1)
          call opqwrt (lo,      iy, lrx - iy + 1, uly + iy - 1)
  120  continue
c
       nx = lrx - ulx - 7
       do 140 iy = uly + 4, lry - 4
          call opqwrt ( hi,  4,     ulx, iy)
          call opqwrt (mid, nx, ulx + 4, iy)
          call opqwrt ( lo,  4, lrx - 3, iy)
  140  continue
c
       return
       end
c
c
c         Draw a smaller sub-panel.
c         -------------------------
c
       subroutine subfrm (ulx, uly, lrx, lry)
c
       implicit none
c
       integer*4 ulx, uly, lrx, lry, nx, iy
       integer*1 lo (1024), mid (1024), hi (1024)
c
       common / frmcom / lo, mid, hi
c
       nx = lrx - ulx + 1
       do 120 iy = 1, 2
          call opqwrt (lo,      iy,          ulx, lry - iy + 1)
          call opqwrt (hi, nx - iy,     ulx + iy, lry - iy + 1)
          call opqwrt (lo, nx - iy,          ulx, uly + iy - 1)
          call opqwrt (hi,      iy, lrx - iy + 1, uly + iy - 1)
  120  continue
c
       nx = lrx - ulx - 3
       do 140 iy = uly + 2, lry - 2
          call opqwrt ( lo,  2,     ulx, iy)
          call opqwrt (mid, nx, ulx + 2, iy)
          call opqwrt ( hi,  2, lrx - 1, iy)
  140  continue
c
       return
       end
c
c
c   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c   *                                                                     *
c   *   opqwrt -- write data to scan converter (horizontal)               *
c   *   ---------------------------------------------------               *
c   *        Special version of scpwrt for Magellan control system.       *
c   *        This version for Tseng Labs, 256 color.                      *
c   *        Writes all 8 bits.                                           *
c   *        The origin of the screen coordinate system is the            *
c   *           upper left-hand corner.                                   *
c   *        The x- and y- coordinates must be inside the                 *
c   *           plotting window: 0 <= x <= (lx - 1) and                   *
c   *           0 <= y <= (ly - 1).  No checking.                         *
c   *                                                                     *
c   *        arguments:                                                   *
c   *             buf    ..... byte array containing image data           *
c   *                          must be at least nb long                   *
c   *                                                                     *
c   *             nb     ..... number of bytes to transfer                *
c   *                          type = integer * 4                         *
c   *                                                                     *
c   *             kx     ..... starting x coordinate                      *
c   *                          type = integer * 4                         *
c   *                          range is 0 to (lx - 1)                     *
c   *                                                                     *
c   *             ky     ..... starting y coordinate                      *
c   *                          type = integer * 4                         *
c   *                          range is 0 to (ly - 1)                     *
c   *                                                                     *
c   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
       subroutine opqwrt (buf, nb, kx, ky)
c
       implicit none
c
       integer*4  nb, kx, ky, kxy, ibuf
       integer*4  mb, ib, ib1, ipg, pgadr
       integer*4  page, lpage, npage
       integer*4  opg, dpg, lx, ly, lxy
       integer*2  i2 (2)
       integer*1  buf (1)
c
       common / scpcom / opg, dpg, lx, ly, lxy
c
       equivalence (pgadr, i2)
c
       data  page / x'A0000' /, lpage / x'10000' /
       data npage / x'B0000' /
c
c
c         Determine memory address and page,
c         then select initial page.
c         ----------------------------------
c
       pgadr = kx + (lx * ky)
       ipg = i2 (2)
       i2 (2) = 10
       call outp (x'3CD', ipg)
c
c
c         Write to screen.
c         ----------------
c
       mb = nb
       ibuf = 1
c
   60  continue
       ib = min (mb, npage - pgadr)
       call blk_bm (buf (ibuf), x'34', pgadr, ib)
c
c
c         Increment byte count and loop.
c         ------------------------------
c
       mb = mb - ib
       if (mb .le. 0)  RETURN
c
       ibuf = ibuf + ib
       pgadr = page
       ipg = ipg + 1
       call outp (x'3CD', ipg)
       go to 60
c
       end
c
