c
c
c         Write cursors to data array.
c         ----------------------------
c
       subroutine curwrt (i1buf)
c
       implicit  none
c
       integer*4 incur, xcur (5), ycur (5)
       integer*4 i, i4, cptr, curptr (144)
       integer*4 xptr, yptr, ic
       integer*1 i1buf (1), i1 (4), cursav (144)
c
       common / cr1com / incur, xcur, ycur
       common / cr2com / curptr (144), cursav
c
       equivalence (i4, i1 (1))
c
       i4 = incur + 16
c
c
c         Cursors 1 to 4 are 9 x 9 crosses.
c         First draw the horizontal part.
c         Save the original values in order.
c         ----------------------------------
c
c
       cptr = 1
       do 190 ic = 1, 4
          yptr = 252 * (ycur (ic) / 40)
          xptr = - 3 + (xcur (ic) / 40)
          if (xptr .lt. 1) xptr = xptr + 250
          do 110 i = 1, 9
             curptr (cptr) = yptr + xptr
             cursav (cptr) = i1buf (yptr + xptr)
             i1buf (yptr + xptr) = i1 (1)
             xptr = xptr + 1
             if (xptr .gt. 250) xptr = xptr - 250
             cptr = cptr + 1
  110     continue
c
c
c         The draw the vertical part.
c         ---------------------------
c
          xptr = 1 + (xcur (ic) / 40)
          yptr = 252 * ((ycur (ic) / 40) - 4)
          if (yptr .lt. 0) yptr = yptr + 63000
          do 120 i = 1, 9
             curptr (cptr) = yptr + xptr
             cursav (cptr) = i1buf (yptr + xptr)
             i1buf (yptr + xptr) = i1 (1)
             yptr = yptr + 252
             if (yptr .ge. 63000) yptr = yptr - 63000
             cptr = cptr + 1
  120     continue
c
  190  continue
c
c
c         Cursor 5 is a square which completely
c         encloses a 17 x 17 area.  There are 4
c         18-pixel sides.  Each side covers just
c         one corner.
c         First draw the top side.
c         --------------------------------------
c
       yptr = 252 * ((ycur (5) / 40) - 9)
       if (yptr .lt. 0) yptr = yptr + 63000
       xptr = (xcur (5) / 40) - 8
       if (xptr .lt. 1) xptr = xptr + 250
       do 210 i = 1, 18
          curptr (cptr) = yptr + xptr
          cursav (cptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          xptr = xptr + 1
          if (xptr .gt. 250) xptr = xptr - 250
          cptr = cptr + 1
  210  continue
c
c
c         Then draw the left side.
c         ------------------------
c
       yptr = 252 * ((ycur (5) / 40) - 8)
       if (yptr .lt. 0) yptr = yptr + 63000
       xptr = (xcur (5) / 40) - 8
       if (xptr .lt. 1) xptr = xptr + 250
       do 220 i = 1, 18
          curptr (cptr) = yptr + xptr
          cursav (cptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          yptr = yptr + 252
          if (yptr .ge. 63000) yptr = yptr - 63000
          cptr = cptr + 1
  220  continue
c
c
c         Then draw the bottom.
c         ---------------------
c
       yptr = 252 * ((ycur (5) / 40) + 9)
       if (yptr .ge. 63000) yptr = yptr - 63000
       xptr = (xcur (5) / 40) - 7
       if (xptr .lt. 1) xptr = xptr + 250
       do 230 i = 1, 18
          curptr (cptr) = yptr + xptr
          cursav (cptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          xptr = xptr + 1
          if (xptr .gt. 250) xptr = xptr - 250
          cptr = cptr + 1
  230  continue
c
c
c         Finally, draw the right side.
c         -----------------------------
c
       yptr = 252 * ((ycur (5) / 40) - 9)
       if (yptr .lt. 0) yptr = yptr + 63000
       xptr = (xcur (5) / 40) + 10
       if (xptr .gt. 250) xptr = xptr - 250
       do 240 i = 1, 18
          curptr (cptr) = yptr + xptr
          cursav (cptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          yptr = yptr + 252
          if (yptr .ge. 63000) yptr = yptr - 63000
          cptr = cptr + 1
  240  continue
c
       return
       end
c
c
c         Restore data array at cursor locations.
c         ---------------------------------------
c
       subroutine currst (i1buf)
c
       implicit  none
c
       integer*4 cptr, curptr (144)
       integer*1 cursav (144), i1buf (1)
c
       common / cr2com / curptr, cursav
c
       do 100 cptr = 144, 1, -1
          i1buf (curptr (cptr)) = cursav (cptr)
  100  continue
c
       return
       end
c
c
c         Cover up the cursors in video memory.
c
c         The cursors need to be covered up in
c         reverse order from the way they were
c         originally drawn.
c
c         The upper-left hand corner of the
c         video are is at X = 224, Y = 98.
c         ------------------------------------
c
       subroutine curfix
c
       implicit  none
c
       integer*4 xptr, yptr, xp, yp, incur, ic
       integer*4 cptr, i, xcur (5), ycur (5), curptr (144)
       integer*1 cursav (144)
c
       common / cr1com / incur, xcur, ycur
       common / cr2com / curptr, cursav
c
       cptr = 144
c
c
c         First, the right side of the box.
c         ---------------------------------
c
c
       xptr = (xcur (5) / 40) + 9
       yptr = (ycur (5) / 40) + 8
       call xywrap (xptr, yptr)
       do 110 i = 1, 18
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
          yptr = yptr - 1
          if (yptr .lt. 0) yptr = yptr + 250
          cptr = cptr - 1
  110  continue
c
c
c         Then, the bottom of the box.
c         ----------------------------
c
       xptr = (xcur (5) / 40) + 9
       yptr = (ycur (5) / 40) + 9
       call xywrap (xptr, yptr)
       do 120 i = 1, 18
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
          xptr = xptr - 1
          if (xptr .lt. 0) xptr = xptr + 250
          cptr = cptr - 1
  120  continue
c
c
c         Then, the left side of the box.
c         -------------------------------
c
       xptr = (xcur (5) / 40) - 9
       yptr = (ycur (5) / 40) + 9
       call xywrap (xptr, yptr)
       do 130 i = 1, 18
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
          yptr = yptr - 1
          if (yptr .lt. 0) yptr = yptr + 250
          cptr = cptr - 1
  130  continue
c
c
c         Finally, the top of the box.
c         ----------------------------
c
       xptr = (xcur (5) / 40) + 8
       yptr = (ycur (5) / 40) - 9
       call xywrap (xptr, yptr)
       do 140 i = 1, 18
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
          xptr = xptr - 1
          if (xptr .lt. 0) xptr = xptr + 250
          cptr = cptr - 1
  140  continue
c
c
c         Now the crosses --
c         vertical part first.
c         --------------------
c
       do 190 ic = 4, 1, -1
          xptr = (xcur (ic) / 40)
          yptr = (ycur (ic) / 40) + 4
          call xywrap (xptr, yptr)
          do 160 i = 1, 9
             xp = xptr
             yp = yptr
ccc             call xyflip (xp, yp)
             call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
             yptr = yptr - 1
             if (yptr .lt. 0) yptr = yptr + 250
             cptr = cptr - 1
  160     continue
c
c
c         Then the horizontal part.
c         -------------------------
c
          xptr = (xcur (ic) / 40) + 4
          yptr = (ycur (ic) / 40)
          call xywrap (xptr, yptr)
          do 180 i = 1, 9
             xp = xptr
             yp = yptr
ccc             call xyflip (xp, yp)
             call opqwrt (cursav (cptr), 1, 224 + xp, 98 + yp)
             xptr = xptr - 1
             if (xptr .lt. 0) xptr = xptr + 250
             cptr = cptr - 1
  180     continue
c
  190  continue
c
       return
       end
c
c
c         Write the cursors into video memory.
c         ------------------------------------
c
       subroutine curvid
c
       implicit  none
c
       integer*4 incur, xcur (5), ycur (5)
       integer*4 i, ic, cptr, i4, curptr (144)
       integer*4 xptr, yptr, xp, yp
       integer*1 i1buf (63000), i1 (4), cursav (144)
c
       common / cr1com / incur, xcur, ycur
       common / cr2com / curptr, cursav
       common / scbcom / i1buf
c
       equivalence (i4, i1 (1))
c
       i4 = incur + 16
       cptr = 1
c
c
c         Start with the 4 crosses.
c         -------------------------
c
       do 190 ic = 1, 4
          xptr = (xcur (ic) / 40) - 4
          yptr = (ycur (ic) / 40)
          call xywrap (xptr, yptr)
c
          do 110 i = 1, 9
             cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
             xp = xptr
             yp = yptr
ccc             call xyflip (xp, yp)
             call opqwrt (i4, 1, 224 + xp, 98 + yp)
             xptr = xptr + 1
             if (xptr .gt. 249) xptr = xptr - 250
             cptr = cptr + 1
  110     continue
c
          xptr = (xcur (ic) / 40)
          yptr = (ycur (ic) / 40) - 4
          call xywrap (xptr, yptr)
c
          do 120 i = 1, 9
             cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
             xp = xptr
             yp = yptr
ccc             call xyflip (xp, yp)
             call opqwrt (i4, 1, 224 + xp, 98 + yp)
             yptr = yptr + 1
             if (yptr .gt. 249) yptr = yptr - 250
             cptr = cptr + 1
  120     continue
c
  190  continue
c
c
c         Now do the 4 sides of the box,
c         starting with the top.
c         ------------------------------
c
       xptr = (xcur (5) / 40) - 9
       yptr = (ycur (5) / 40) - 9
       call xywrap (xptr, yptr)
       do 240 i = 1, 18
          cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (i4, 1, 224 + xp, 98 + yp)
          xptr = xptr + 1
          if (xptr .gt. 249) xptr = xptr - 250
          cptr = cptr + 1
  240  continue
c
c
c         Then draw the left side.
c         ------------------------
c
       xptr = (xcur (5) / 40) - 9
       yptr = (ycur (5) / 40) - 8
       call xywrap (xptr, yptr)
       do 260 i = 1, 18
          cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (i4, 1, 224 + xp, 98 + yp)
          yptr = yptr + 1
          if (yptr .gt. 249) yptr = yptr - 250
          cptr = cptr + 1
  260  continue
c
c
c         Then draw the bottom.
c         ---------------------
c
       xptr = (xcur (5) / 40) - 8
       yptr = (ycur (5) / 40) + 9
       call xywrap (xptr, yptr)
       do 280 i = 1, 18
          cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (i4, 1, 224 + xp, 98 + yp)
          xptr = xptr + 1
          if (xptr .gt. 249) xptr = xptr - 250
          cptr = cptr + 1
  280  continue
c
c
c         Finally, draw the right side.
c         -----------------------------
c
       xptr = (xcur (5) / 40) + 9
       yptr = (ycur (5) / 40) - 9
       call xywrap (xptr, yptr)
       do 300 i = 1, 18
          cursav (cptr) = i1buf ((252 * yptr) + xptr + 1)
          xp = xptr
          yp = yptr
ccc          call xyflip (xp, yp)
          call opqwrt (i4, 1, 224 + xp, 98 + yp)
          yptr = yptr + 1
          if (yptr .gt. 249) yptr = yptr - 250
          cptr = cptr + 1
  300  continue
c
       return
       end
c
c
c         Check XY coords and wrap.
c         -------------------------
c
       subroutine xywrap (xval, yval)
c
       implicit  none
c
       integer*4 xval, yval
c
       if (xval .lt.   0) xval = xval + 250
       if (xval .gt. 249) xval = xval - 250
       if (yval .lt.   0) yval = yval + 250
       if (yval .gt. 249) yval = yval - 250
c
       return
       end
c
c
c         Write the guider box
c         to the data array.
c         --------------------
c
       subroutine boxwrt (i1buf)
c
       implicit none
c
       real*4    sens, pa, px
       integer*4 i4, ib, gdrfl, xflip, yflip, box
       integer*4 bptr, xptr, yptr, boxptr (300)
       integer*1 i1buf (1), i1 (4), boxsav (300)
c
       common / gdrcom / gdrfl, sens, xflip, yflip, pa, px, box
c
       equivalence (i4, i1 (1))
c
       data i4 / 79 /
c
c
c         First draw the top side.
c         ------------------------
c
       bptr = 1
c
       yptr = (box + 1) / 2
       yptr = 75 * (35 - yptr)
       xptr = (box + 1) / 2
       xptr = 36 - xptr
       do 210 ib = 1, box + 2
          boxptr (bptr) = yptr + xptr
          boxsav (bptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          xptr = xptr + 1
  210  continue
c
c
c         Then draw the left side.
c         ------------------------
c
       yptr = (box + 1) / 2
       yptr = 75 * (35 - yptr)
       xptr = (box + 1) / 2
       xptr = 36 - xptr
       do 220 ib = 1, box + 2
          boxptr (bptr) = yptr + xptr
          boxsav (bptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          yptr = yptr + 75
  220  continue
c
c
c         Then draw the bottom.
c         ---------------------
c
       yptr = (box + 1) / 2
       yptr = 75 * (35 + yptr)
       xptr = (box + 1) / 2
       xptr = 36 - xptr
       do 230 ib = 1, box + 2
          boxptr (bptr) = yptr + xptr
          boxsav (bptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          xptr = xptr + 1
  230  continue

c
c
c         Finally, draw the right side.
c         -----------------------------
c
       yptr = (box + 1) / 2
       yptr = 75 * (35 - yptr)
       xptr = (box + 1) / 2
       xptr = 36 + xptr
       do 240 ib = 1, box + 2
          boxptr (bptr) = yptr + xptr
          boxsav (bptr) = i1buf (yptr + xptr)
          i1buf (yptr + xptr) = i1 (1)
          yptr = yptr + 75
  240  continue
c
       return
       end