c
c
c         Mouse input routine for
c         Magellan guider camera.
c         ---------------------------
c
       subroutine mcheck
c
       implicit none
c
       real*4    delx, dely, delaz, delel
       real*4    radpa, sinpa, cospa
       integer*4 newx, newy
       integer*4 mx, my
       integer*4 mbbits
       logical*4 mbpush
       integer*4 chrcnt
c
       integer*4 incur, xcur (5), ycur (5)
       common / cr1com / incur, xcur, ycur
       integer*4 gdrfl, xflip, yflip, box
       real*4    sens, pa, px
       common / gdrcom / gdrfl, sens, xflip, yflip, pa, px, box

       real*4    rx, ry, cx, cy
       integer*4 bbits
       integer*4 msecur, gdrcur
       common / msecom / rx, ry, cx, cy, bbits, msecur, gdrcur
       integer*4 mmoden, mclick
       common / mmdcom / mmoden, mclick
       integer*4 camlen
       character*22 camcmd
       common / camcom / camlen, camcmd
       integer*4 camnum
       common / cnncom / camnum

       data mbpush / .false. /

c
c
c         Look for motion.  The screen coordinates
c         rx and ry have values in the range - 1.0 to + 1.0.
c         However, the geometry of the
c         screen is assumed to have a 4/3 aspect ratio.
c         The value of rx increases to the
c         right.  The value of ry increases down.
c         ----------------------------------------
c
       call read_motion (mx, my)
c
       if ((mx .ne. 0) .or. (my .ne. 0)) then
          rx = rx + (mx / 300.)
          rx = max (rx, -1.)
          rx = min (rx,  1.)
c
          ry = ry + (my / 300.)
          ry = max (ry, -1.)
          ry = min (ry,  1.)
c
          newx = xcur(msecur)
          newy = ycur(msecur)

          newx = newx + (mx / 300.) * 5000.0
          newx = max (newx,    0)
          newx = min (newx, 9999)
          newy = newy + (my / 300.) * 5000.0
          newy = max (newy,    0)
          newy = min (newy, 9999)

          call curupa (msecur, newx, newy)
       endif
c
c
c
c         Check for left button-press.
c         ----------------------------
c
       call get_mouse (bbits, mx, my)
       if (mmoden .eq. 1) then
           mbbits = or (bbits, mclick)
           mclick = 0
           if (and(mbbits,1) .ne. 0) then
               if (.not. mbpush) then
                   if (and(mbbits,2) .ne. 0) then
                       newx = xcur(msecur)
                       newy = ycur(msecur)
                   else
                       newx = (xcur(msecur)-xcur(gdrcur))/10 +
     :                   xcur(gdrcur)
                       newy = (ycur(msecur)-ycur(gdrcur))/10 +
     :                   ycur(gdrcur)
                   endif
                   call curupa (gdrcur, newx, newy)
               endif
               mbpush = .true.
           else
               mbpush = .false.
           endif
       elseif (mmoden .eq. 2) then
           mbbits = or (bbits, mclick)
           mclick = 0
           if (and(mbbits,1) .ne. 0) then
               if (.not. mbpush) then
                   if (and(mbbits,2) .ne. 0) then
                       delx = (xcur(msecur)-xcur(gdrcur))
                       dely = (ycur(msecur)-ycur(gdrcur))
                   else
                       delx = (xcur(msecur)-xcur(gdrcur))/10.0
                       dely = (ycur(msecur)-ycur(gdrcur))/10.0
                   endif
                   radpa = abs (pa) / 57.29578
                   sinpa = sin (radpa)
                   cospa = cos (radpa)
                   if (pa .gt. 0.) then
                      delaz = + (delx * cospa) - (dely * sinpa)
                      delel = - (delx * sinpa) - (dely * cospa)
                   else
                      delaz = - (delx * cospa) - (dely * sinpa)
                      delel = + (delx * sinpa) - (dely * cospa)
                   endif
                   delaz = -0.1 * delaz * px
                   delel = -0.1 * delel * px
                   camcmd = 'gpaer0 0000.00 0000.00'
                   camcmd(6:6) = char (48 + camnum)
                   call fform (delaz, camcmd( 8:14), 2, 1)
                   call fform (delel, camcmd(16:22), 2, 1)
                   camlen = chrcnt (camcmd)
               endif
               mbpush = .true.
           else
               mbpush = .false.
           endif
       endif
c
       return
       end
       subroutine curupr (n, dx, dy)
       integer*4 n, dx, dy
       integer*4 x, y

       integer*4 incur, xcur (5), ycur (5)
       common / cr1com / incur, xcur, ycur

       x = xcur(n) + dx
       y = ycur(n) + dy
       call curupa (n, x, y)
       end
       subroutine curupa (n, newx, newy)
       integer*4 n, newx, newy
       integer*4 x, y

       integer*4 incur, xcur (5), ycur (5)
       common / cr1com / incur, xcur, ycur
       integer*4 xfsflg, exftim, exstim
       common / xfscom / xfsflg, exftim, exstim
       integer*4 binf, bins
       common / bincom / binf, bins

       x = newx
       y = newy
100    continue
       if (x .lt. 0) then
           x = x + 10000
           go to 100
       endif
200    continue
       if (y .lt. 0) then
           y = y + 10000
           go to 200
       endif
       x = mod (x, 10000)
       y = mod (y, 10000)
       if (n .eq. 5) then
           x = max (400, min (9599, x))
           y = max (400, min (9599, y))
       endif
       call curfix
       xcur(n) = x
       ycur(n) = y
       call vbox (n + 20, xcur(n))
       call vbox (n + 30, ycur(n))
       call curvid
       if (n .eq. 5) then
          if (xfsflg .eq. 0) then
             call magnif
          else
             call dspset (- bins)
          endif
       else
          call curval (n)
       endif
       end
