c
c
c         Display system messages for
c         Magellan telescope control
c         program.
c         ---------------------------
c
       subroutine dspmsg (fnc)
c
       implicit  none
c
       integer*4 fnc, step, clkptr, cptr
       integer*4 msgptr, iptr, jptr, brwsptr
       logical*4 brwsfl
c
       character*50 sysmsg (1000)
       character*40 clkmsg (100)
c
       common / msgcom / msgptr, sysmsg
       common / msgctl / brwsfl, brwsptr, iptr
       common / clklog / clkptr, clkmsg
c
       data iptr / 0 /, step / 0 /, brwsfl / .false. /
       data cptr / 0 /
c
c
c         Transfer any new messages in
c         the clock routine error log.
c         ----------------------------
c
  100  continue
       if (cptr .ne. clkptr) then
          cptr = cptr + 1
          if (cptr .gt. 100) cptr = 1
          call putmsg (clkmsg (cptr))
          go to 100
       endif
c
c
c         Scroll the message display
c         as necessary to display the
c         appropriate messages.
c         ---------------------------
c
       if (step .eq. 0) then
          if (.not. brwsfl) then
             if (iptr .ne. msgptr) then
                iptr = msgptr
                call mbox (5, sysmsg (iptr))
                step = 1
             endif
          else
             if (iptr .ne. brwsptr) then
                iptr = brwsptr
                call mbox (15, sysmsg (iptr))
                step = 1
             endif
          endif
c
       elseif (step .lt. 5) then
          jptr = iptr - step
          if (jptr .lt. 1) jptr = 1000 + jptr
          call mbox (15 - step, sysmsg (jptr))
          step = step + 1
       elseif (step .eq. 5) then
          call mbox (21, jptr - 1)
          step = 6
       elseif (step .eq. 6) then
          call mbox (22, iptr - 1)
          step = 0
       endif
c
       return
       end
c
c
c         Put a message into the
c         system message log.
c         ----------------------
c
       subroutine putmsg (msg)
c
       implicit none
c
       real*8    utime, mjd
       real*4    r4
       integer*4 nch, msgptr
       integer*4 hmsf (4), mjday
c
       character*50 sysmsg (1000), blank
       character    msg*(*), csgn*1
c
       common / msgcom / msgptr, sysmsg
       common / clkcom / utime, mjday
c
       data blank
     :  / '                                                  ' /
c
c
c         Transfer the message,
c         up to 37 chars.
c         ---------------------
c
       msgptr = msgptr + 1
       if (msgptr .gt. 1000) msgptr = 1
       sysmsg (msgptr) = blank
       nch = min (len (msg), 37)
       if (nch .gt. 0) then
          call memcpy (sysmsg (msgptr) (14:14), msg, nch)
       endif
c
c
c         Encode the time.
c         ----------------
c
       mjd = utime
       call sla_dd2tf (2, mjd, csgn, hmsf)
       call iform (hmsf (1), sysmsg (msgptr) (1:2), 2)
       call iform (hmsf (2), sysmsg (msgptr) (4:5), 2)
       r4 = hmsf (3) + (hmsf (4) / 100.)
       call fform (r4, sysmsg (msgptr) (7:11), 2, 2)
c
c
c         Add this message to the EDS
c         (Engineering Data Stream).
c         ---------------------------
c
       call puteds (1, sysmsg (msgptr))
c
       return
       end
c
