       subroutine plsphot (x, z, e, n, fit, it)
c
       implicit   none
c
       real*4     x (1), z (1), e (1), chisq, chi2
       real*4     a (6), fa (6), c (6, 6), acc (6), alim (6)
       real*4     r4, av, area, fmaj, fmin, angle, fit (6)
       integer*4  n, m, it, lverb, ifit (2)
       integer*4  i, imax
       integer*2  i2 (2)
       logical*4  needit
c
       external   pseud2d
c
       equivalence (r4, i2)
c
       common  / tune14 / lverb
       common  / drfake / needit
c
       data   acc /   .01,  -.03,  -.03,   .01,   .03,    .1 /
c
c
c         The alim array provides a sanity
c         check for for the parameters of
c         the fit during each iteration.
c         --------------------------------
c
ccc    data  alim / -1.e8, -1.e3, -1.e3, -1.e8, -1.e3, -1.e3 /
ccc    data  alim / -255.,  -10.,  -10., -500., +100., -1.e3 /
       data  alim / -1.e4,  -10.,  -10., -3.e4, +100., -1.e3 /
c
       lverb = 0
       needit = .true.
c
       m  = 5
c
       r4 = -1.e10
       av = 0.
       do 120 i = 1, n
          av = av + z (i)
          if (z (i) .gt. r4) then
             imax = i
             r4 = z (i)
          endif
  120  continue
       av = av / n
c
       if (it .eq. 0) then
          r4    = x (imax)
          a (1) = av
          a (2) = i2 (1)
          a (3) = i2 (2)
          a (4) = z (imax) - av
          a (5) = 8.
       endif
c
       it = 8
       chi2 = chisq (pseud2d, x, z, e, n, a, fa, c, m, acc, alim, it)
       if (chi2 .eq. 1.e10) it = - it
c
       call ellipse (a (5), area, fmaj)
       area  = area * a (4)
       fit (1) = a (1)
       fit (2) = a (2)
       fit (3) = a (3)
       fit (4) = area
       fit (5) = fmaj
       fit (6) = z (imax)
c
       return
       end
c
c
c
c
c
      FUNCTION CHISQ (FUNCTN,X,Y,YE,N,A,FA,C,M,ACC,ALIM,IT)
      PARAMETER (MMAX = 11)
      common /tune14/ lverb
      DIMENSION A(m+1), FA(m+1), C(M+1,M+1), ACC(m+1), ALIM(m+1)
      CHARACTER*80 FMT1
      EXTERNAL FUNCTN
      LOGICAL CONV, MARQ, LIMIT
      logical*4 test, ludcmp
c      real*8 chi,chiold
      DIMENSION X(n), Y(n), YE(n)
      DIMENSION V(MMAX), B(MMAX,MMAX), INDX(MMAX)
      DATA FMT1 /'(I3,I2,1P11E10.2)'/
      DATA IZ /0/
c
      IF(M.GT.MMAX-1)RETURN
      CONV = .FALSE.
      LIMIT = .FALSE.
      DO 2757 J=1,M
C
C     CHECK IF PARAMETERS EXCEEDS LIMITS AT THE START.  CHECK ONLY
C     ABSOLUTE PARAMETERS (ALIM(J) < 0).
C
         IF (ALIM(J) .LT. 0.0) THEN
            LIMIT = ABS(A(J)).GT.ABS(ALIM(J))
            IF(LIMIT) then
            if(lverb.gt.20)
     *  write(6,*) 'SELF-DECEPTION HAS OCCURED: INITIAL LIMITS.'
            end if
         END IF
 2757 CONTINUE
      if(lverb.gt.30) print FMT1, IZ,IZ,(A(KK),KK=1,M)
      IFACT = 0
      I = 1
 2758 IF ((I .LE. IT) .AND. (.NOT. CONV) .AND. (.NOT. LIMIT)) THEN
         CHI = 0.0
         DO 2759 J=1,M
	    B(J,M+1)=0
	    DO 2760 KK=1,M			
               B(J,KK)=0
 2760       CONTINUE
 2759    CONTINUE
         DO 2761 J=1,N
	    F = FUNCTN(X(J), A, FA, M, MMAX) - Y(J)
            F2 = F**2
            YE1 = 1.0/YE(J)
 	    CHI = CHI + F2*YE1
	    DO 2762 KK=1,M
               IF (FA(KK) .NE. 0) THEN
                  FAKK = FA(KK)/YE(J)
                  B(KK,M+1)=B(KK,M+1)+FAKK*F
                  DO 2763 L=1,KK
                     IF (FA(L) .NE. 0)
     1                    B(KK,L)=B(KK,L)+FAKK*FA(L)	
 2763             CONTINUE
               END IF
 2762       CONTINUE
 2761    CONTINUE
         CHIOLD = CHI
         K = 1
         MARQ = .FALSE.
 2764    IF ((K .LE. 10) .AND. (.NOT. MARQ) .AND. (.NOT. LIMIT)) THEN
	    CONV = (K .EQ. 1)
	    IF (K .EQ. 1)  FACT = 0.
	    IF (K .NE. 1)  FACT = 2.**IFACT
	    DO 2765 J=1,M
               L = 1
 2766          IF (L .LT. J) THEN
                  C(J,L)=B(J,L)
                  C(L,J)=B(J,L)
                  L = L + 1
                  GO TO 2766
               END IF
               C(J,J)=(1+FACT)*B(J,J)
               V(J) = B(J,M+1)
 2765       CONTINUE
	    test = LUDCMP(C,M,M+1,INDX,D)
      if (.not. test) return
	    CALL LUBKSB(C,M,M+1,INDX,V)
	    DO 2767 J=1,M
               A(J)=A(J)-V(J)
C
C     CHECK IF CHANGE IN PARAMETERS EXCEEDS LIMITS.  IF ALIM(J) > 0, THEN
C     CONSIDER FRACTIONAL CHANGES.  IF ALIM(J) < 0, CONSIDER ABSOLUTE
C     CHANGES.  IF ALIM(J) = 0, IGNORE THIS TEST.
C
               IF (ALIM(J) .GT. 0.0) THEN
                  LIMIT = LIMIT.OR.(ABS(V(J)/A(J)).GT.ALIM(J))
                  IF(LIMIT) then
                  if(lverb.gt.20)
     *    write(6,*) 'SELF-DECEPTION HAS OCCURED: FRAC LIMITS.'
                  end if
               ELSE IF (ALIM(J) .LT. 0.0) THEN
                  LIMIT = LIMIT.OR.(ABS(A(J)).GT.ABS(ALIM(J)))
                  IF(LIMIT) then
                  if(lverb.gt.20)
     *    write(6,*) 'SELF-DECEPTION HAS OCCURED: ABS LIMITS.'
                  end if
               END IF
C
               IF (ACC(J) .GE. 0) THEN
                  CONV=CONV.AND.(ABS(V(J)/A(J)).LE.ACC(J))
               ELSE
                  CONV=CONV.AND.(ABS(V(J)).LE.ABS(ACC(J)))
               END IF	
 2767       CONTINUE
c
            if(lverb.gt.30) print FMT1, I,K,(A(KK),KK=1,M)
	    IF (CONV) THEN		
               MARQ = .TRUE.
	    ELSE IF (.NOT. LIMIT) THEN
               CHI = 0.0
               DO 2768 J = 1, N
                  F = FUNCTN(X(J), A, FA, 0, MMAX) - Y(J)
                  F2 = F**2
                  YE1 = 1.0/YE(J)
                  CHI = CHI + F2*YE1
 2768          CONTINUE
               IF (K .EQ. 2) IFACT = IFACT - 1
               IF (CHI .LT. (1.0001 * CHIOLD)) THEN
                  MARQ = .TRUE.
               ELSE
                  IF(K .EQ. 2)  IFACT = IFACT + 1
                  IF (K .GE. 2) IFACT = IFACT + 1
                  IF(IFACT.GT.10)GO TO 50
                  DO 2769 J=1,M
                     A(J)=A(J)+V(J)
 2769             CONTINUE
               END IF
	    END IF
	    K = K + 1
            GO TO 2764
         END IF
c         write (*, '(f9.2, f9.2, f10.2, f6.2, f6.2, f9.2)')
c     :      a (2), a (3), a (4), a (5), a (7), a (1)
         I = I + 1
         GO TO 2758
      END IF
 50   CONTINUE
      it = i - 1
C
      IF(.NOT. LIMIT) THEN
         DO 2770 J = 1, M			
            DO 2771 I = 1, M
               B(I,J) = 0
 2771       CONTINUE
            B(J,J) = 1
            CALL LUBKSB(C,M,M+1,INDX,B(1,J))
 2770    CONTINUE
      END IF
C
      IF (CONV .AND. (.NOT. LIMIT)) THEN
         PERDEG = SQRT(CHI/MAX0(N-M,1))
         DO 2772 I=1,M
	    IF (B(I,I) .GT. 0) THEN
               SAVE=SQRT(B(I,I))
	    ELSE
               if(lverb.gt.20) write(6,*)
     *  'TROUBLE: NEGATIVE AUTOVARIANCE FOR I, B(I,I) = ',I,B(I,I)
               SAVE = 1E10
	    END IF
	    DO 2773 J=1,M
               C(I,J)=B(I,J)/SAVE
               C(J,I)=B(J,I)/SAVE
 2773       CONTINUE
	    C(I,I)=SAVE*PERDEG
 2772    CONTINUE
         CHISQ=CHIOLD
      ELSE
         CHISQ = 1E10
      END IF
      RETURN
      END
C
C
C:  UNTESTED
C
       FUNCTION PSEUD2D(IX, A, FA, M, MMAX)
C
       COMMON / DRFAKE / NEEDIT
C
       DIMENSION A(1), FA(1)
       INTEGER*2 IX(2)
       LOGICAL NEEDIT
C
       DATA HALF, THIRD / 0.5, 0.3333333 /
       DATA EXPMIN / -23. /
C
       X = IX (1) - A (2)
       Y = IX (2) - A (3)
       A5 = 1. / A (5)
       T5 = A5 * X
       T7 = A5 * Y
       T1 = HALF * ((T5 * X) + (T7 * Y))
C
       IF (T1 .GT. 0.) THEN
          T2    = HALF * T1 * T1
          DDDT  = 1. + T1 + T2
          DENOM = DDDT + (THIRD * T1 * T2)
          PEXP  = 1. / DENOM
C
       ELSE
          T1    = AMAX1 (T1, EXPMIN)
          PEXP  = EXP (-T1)
          DENOM = 1.
          DDDT  = 1.
       ENDIF
C
       FA (4)  = PEXP
       PEXP    = A (4) * PEXP
       PSEUD2D = PEXP + A (1)
C
       IF (NEEDIT) THEN
          FA (5) = FA (4) * PEXP * DDDT
          FA (2) = T5 * FA (5)
          FA (3) = T7 * FA (5)
          FA (5) = HALF * ((T5 * FA (2)) + (T7 * FA (3)))
          FA (1) = 1.
       ENDIF
C
       RETURN
       END
c
c
c
c
c
      logical*4 function LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=100,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)
      ludcmp = .true.
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
c        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        if (aamax .eq. 0.) then
c           write (*, *) '  singular matrix.'
           ludcmp = .false.
           return
        endif
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
      RETURN
      END
c
c
c
c
c
      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
c
c
c
c
c
       SUBROUTINE ELLIPSE (B5, AREA, AMAJ)
c
       IF (B5 .GT. 0.) THEN
          AREA = 6.2832  * B5
          AMAJ = 2.35482 * SQRT (B5)
       ELSE
          AREA = 0.
          AMAJ = 0.
       END IF
c
       RETURN
       END
