c
c
c         Initialization program for
c         Magellan guider cameras.
c         --------------------------
c
       subroutine gcset (rmvec)
c
       implicit  none
c
       real*8    utime, utset, djm
       real*4    r4, sens, pa, px
       integer*4 gdrfl, xflip, yflip, box
       integer*4 rmvec, clock1
       integer*4 ier, graphics_mode, i
       integer*4 mm, dd, yy, ww, mjday
       integer*4 hh, ss, hs, clkfl, ppm
       integer*4 incur, xcur (5), ycur (5)
       integer*4 dspini, dsperr, binf, bins
       integer*4 dspflg (47), dspval (47)
       integer*4 pctset, pctval, pctprv, zzero, zspan
       integer*4 zero, bkgset, dsab_ex
       integer*4 xfsflg, exftim, exstim
       integer*4 gain, usec, hdir, tec, gate
       integer*4 blk,  gry,  hlt,  wht
       integer*4 red,  yel,  grn,  bkg
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       logical*4 rdini
       integer*4 uplip (4), errct, uplprt
       character*1 cn
       integer*4 camnum
       integer*4 mmoden, mclick, fmoden, gmoden
c
       integer*1 lo (1024), mid (1024), hi (1024)
       integer*1 scrbuf (63000)
c
       character chr3*3
c
       common / clkcom / utime, mjday
       common / clkctl / utset, clkfl, ppm
c
       common / cr1com / incur, xcur, ycur
       common / dspcom / dspini, dsperr, dspflg, dspval
       common / xfscom / xfsflg, exftim, exstim
       common / bincom / binf, bins
       common / ampcom / gain, usec, hdir, tec, gate
       common / scbcom / scrbuf
       common / pctcom / pctset, pctval, pctprv
       common / zptcom / zzero, zspan
       common / zrocom / zero, bkgset
       common / gdrcom / gdrfl, sens, xflip, yflip, pa, px, box
c
       common / colors  / blk,  gry,  hlt,  wht,
     :                    red,  yel,  grn,  bkg
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
       common / frmcom  / lo, mid, hi
       common / uplcom / uplip, errct, uplprt
       common / cnncom / camnum
       common / mmdcom / mmoden, mclick, fmoden, gmoden
c
       data  binf / 2 /, bins / 2 /
       data  xcur / 0, 0, 0, 0, 400 /, ycur / 0, 0, 0, 0, 400 /
       data  dspini / 1 /, dsperr / 0 /, incur / 0 /
       data  dspflg / 47 * 0 /, dspval / 47 * 0 /
       data  xfsflg / 0 /, exftim / 350 /, exstim / 350 /
       data  zzero / 0 /, zspan / 5000 /, bkgset / 16 /
       data  pctset / 25 /, pctval / 1500 /
       data  gain / 0 /, usec / 16 /, hdir / 2 /, tec / 4096 /
       data  gate / 2896 /, px / 0.092 /, pa / -55. /, sens / 0.5 /
       data  box / 31 /
c
       data blk /  16 /, gry /  32 /, hlt /  56 /, wht /  68 /
       data red /  94 /, yel / 110 /, grn / 125 /, bkg /  44 /
c
c
c         Mask all NDP exceptions.  This may
c         prevent the program from crashing
c         guiding on nothing.
c
c         You might not want to do this while
c         debugging the prgram, because certain
c         errors might never show up!
c         -------------------------------------
c
       ier = dsab_ex (63)
c
c
c         Read the ini file.
c         ------------------
c
       if (.not. rdini ()) stop
c
c
c         Connect the clock interrupt, then
c         set rate 32X faster (1.7165 msec).
c         ----------------------------------
c
       rmvec = clock1 ()
       call outp (x'43', x'36')
       call outp (x'40', x'00')
       call outp (x'40', x'08')
c
c
c         Initialize fast graphics fonts.
c         -------------------------------
c
       blk1 = 1
       call fontset (fontbuf (blk1), blk, bkg, 1)
       gry1 = blk1 +  8192
       call fontset (fontbuf (gry1), gry, bkg, 1)
       wht1 = gry1 +  8192
       call fontset (fontbuf (wht1), wht, bkg, 1)
       red1 = wht1 +  8192
       call fontset (fontbuf (red1), red, bkg, 1)
       yel1 = red1 +  8192
       call fontset (fontbuf (yel1), yel, bkg, 1)
       grn1 = yel1 +  8192
       call fontset (fontbuf (grn1), grn, bkg, 1)
       blk2 = grn1 +  8192
       call fontset (fontbuf (blk2), blk, bkg, 2)
       grn2 = blk2 + 32768
       call fontset (fontbuf (grn2), grn, bkg, 2)
c
c
c         Initialize video mode
c         and color palette.
c         ---------------------
c
       ier = graphics_mode (x'2E')
       call map
c
c
c         Initialize lo, mid and hi color
c         arrays.  Also initialize the
c         screen buffer.
c         -------------------------------
c
       do 120 i = 1, 1024
          lo (i)  = gry
          mid (i) = bkg
          hi (i)  = hlt
  120  continue
c
       do 140 i = 1, 63000
          scrbuf (i) = bkg
  140  continue
c
c
c         Set the integer modified
c         Julian day number.
c         ------------------------
c
       call dosdat (mm, dd, yy, ww)
       call sla_caldj (yy, mm, dd, djm, ier)
       if (ier .eq. 0) then
          mjday = djm
       else
          call iform (ier, chr3, 1)
          call putmsg ('000: DOS date error, code = '//chr3)
       endif
c
c
c         Set the universal time
c         from the CPU clock.
c         ----------------------
c
       call dostim (hh, mm, ss, hs)
       utset = (hh + (mm / 60.d0) + (ss / 3600.d0)
     :                            + (hh / 3600.d2)) / 24.d0
       clkfl = - 1
c
c
c         System message log.
c         -------------------
c
       call mbox (0)
       call utclk
c
c
c         Command entry box.
c         ------------------
c
       call pbox (0)
c
c
c         Numerical values box
c         --------------------
c
       call vbox (0)
       r4 = exftim * .0017165
       call vbox (6, r4)
       r4 = exstim * .0017165
       call vbox (7, r4)
c
       call vbox (25, xcur (5))
       call vbox (35, ycur (5))
c
       call vbox (55, binf)
       call vbox (56, bins)
c
       call vbox (61, pctset)
       call vbox (63, zspan)
       call vbox (57, zzero)
       call vbox (62, bkgset)
c
       call vbox (64, hdir)
       r4 = - 6.0
       call vbox (65, r4)
c
c
c         Centroid display box.
c         ---------------------
c
       call cbox (0)
       call cbox (8, px)
       call cbox (9, pa)
       call cbox (10, sens)
       call cbox (12, box)
c
c
c         Frame in the rest
c         of the screen.
c         -----------------
c
       call coolfr (216,  1, 481,  87)
       call sbox (1, 0)
       call sbox (2, 0)
       call sbox (3, mmoden)
       call sbox (4, fmoden)
       call sbox (5, gmoden)
       call coolfr (216, 90, 481, 355)
       camnum = mod (uplprt, 10) + 1
       cn = char (48 + camnum)
       call opqchr2 (cn, 460, 6, fontbuf (grn2))
c
       call putmsg ('998; UT clock initialized by CPU')
c
       return
       end
c
c
c         Read INI file for Magellan GCAM. The INI
c         file is REQUIRED, and can only be changed
c         with a text editor.
c
c         Note that the program CANNOT find the INI
c         file if it runs from the root directory.
c         ALWAYS run the program in a subdirectory!
c
c         I think the problem is that the NDP I/O
c         system does not expand the full filename
c         correctly when in the root directory.
c
c         The program would probably run OK with
c         file = a:\gcam.ini, for example.
c         -----------------------------------------
c
       logical*4 function rdini()
c
       implicit none
c
       integer*4 ini
       integer*4 lnum, uplip (4), errct, uplprt
       logical*4 ok
c
       common / uplcom / uplip, errct, uplprt
c
       data  ini / 4 /
c
       ok = .false.
c
       lnum = 0
       open (unit = ini, file = 'gcam.ini',
     :       status = 'old', err = 900      )
c
       lnum = 1
       read (ini, '(i)', err = 900) uplip (1)
c
       lnum = 2
       read (ini, '(i)', err = 900) uplip (2)
c
       lnum = 3
       read (ini, '(i)', err = 900) uplip (3)
c
       lnum = 4
       read (ini, '(i)', err = 900) uplip (4)
c
       lnum = 5
       read (ini, '(i)', err = 900) uplprt
c
       close (ini)
       ok = .true.
c
  900  continue
       if (ok) then
          rdini = .true.
       else
          write (*, *)
          write (*, '(a, i4)')
     :       ' Error reading INI file at line number', lnum
          write (*, '(a)'    )
     :       ' Execution terminated!'
          rdini = .false.
       endif
c
       return
       end
