c
c
c         TCP/IP communication program
c         for Magellan guider cameras.
c         ----------------------------
c
       subroutine tcp
c
       implicit  none
c
       integer*4 eax, ebx, ecx, edx, ncol
       integer*4 bufadr, bufsiz, uplip (4), uplprt
       integer*4 ok, ibuf, nbuf, wbuf, i4, frame
       integer*4 step, errct, dtime, time0, wtime, time2
       integer*4 timer1, timer2, timer3, timer4
       integer*4 sendct, sendsz, sndbuf (250000)
       integer*4 shflag
       logical*4 sendfl
       integer*2 i2 (2), j2, xbuf (512)
       integer*1 xbuf1 (1024)
       character msg*37, cbuf*100
c
       common / timcom / timer1, timer2, timer3, timer4
       common / uplcom / uplip, errct, uplprt
       common / sndcom / sendfl, sendct, sendsz, sndbuf
       common / shmcom / shflag
c
       equivalence (i4, i2 (1)), (xbuf (1), xbuf1 (1))
c
       data step / 0 /, errct / 0 /, time0 / - 35000 /
       data uplip / 200, 28, 147, 5 /, uplprt / 5700 /
       data sendfl / .false. /, sendct / - 1 /
       data frame / 100 /, wtime / 0 /
c
c
c         Skip if error count exceeded.
c         -----------------------------
c
       if (errct .ge. 3) then
          time0 = timer1
	  dtime = timer1 - time2
	  if (dtime .lt. 0) dtime = dtime + 1000000000
	  if ((dtime) .gt. 180000) then
	      errct = 0
	      call putmsg ('979; TCP communications resumed')
	      step = 2
	  endif
          go to 990
       endif
c
c
c         Some operations don't generate
c         status.
c         ------------------------------
c
       ok = 2
c
c
c         Get address of TCP Buffer.
c         --------------------------
c
       if     (step .eq. 0) then
          eax = x'0800'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
c
          bufadr = (16 * eax) + ebx
          bufsiz = ecx
c
          msg = '992; TCP buffer address = XXXXXX'
          call iform (bufadr, msg (27:32), 6)
          call putmsg (msg)
c
          msg = '991; TCP buffer size = XXXX'
          call iform (bufsiz, msg (24:27), 3)
          call putmsg (msg)
c
          step = 1
c
c
c         Open socket.  This is where the
c         host IP address is specified!
c
c         Except on first try, wait one
c         minute for the TCP/IP driver to
c         completely time out.
c
c         On second thought, 5 seconds
c         should do it!
c         -------------------------------
c
       elseif (step .eq. 1) then
          dtime = timer1 - time0
          if (dtime .lt. 0) dtime = dtime + 1000000000
ccc          if (dtime .lt. 35000) go to 990
          if (dtime .lt. 3000) go to 990
c
          eax = 0
          ebx = uplprt
          ecx = (uplip (1) * 256) + uplip (2)
          edx = (uplip (3) * 256) + uplip (4)
          call int097 (eax, ebx, ecx, edx)
c
          if (eax .eq. 0) then
             if (errct .lt. 3)
     :          call putmsg ('980; TCP socket opened')
             time0 = timer1
             step = 3
          else
             if (errct .lt. 3)
     :          call putmsg ('101: TCP Open Socket failure')
             ok = 0
             step = 2
          endif
c
c
c         Abort socket and try again.
c         ---------------------------
c
       elseif (step .eq. 2) then
          eax = x'0B00'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
          time0 = timer1
          step = 1
c
c
c         Tick Socket.
c         ------------
c
       elseif (step .eq. 3) then
          eax = x'0400'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
          step = 4
c
c
c         Check for established socket connection.
c         ----------------------------------------
c
       elseif (step .eq. 4) then
          eax = x'0200'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
c
          if (and (eax, 1) .eq. 1) then
             call putmsg ('990; TCP connection established')
             ok = 1
             step = 5
c
          else
             dtime = timer1 - time0
             if (dtime .lt. 0) dtime = dtime + 1000000000
             if (dtime .gt. 600) then
                if (errct .lt. 3)
     :             call putmsg ('102: TCP connection timeout')
                ok = 0
                step = 2
             else
                step = 3
             endif
          endif
c
c
c         When a send command has been issued, put
c         the header in the transmit buffer.  The
c         variable SENDCT is negative if no send
c         command is pending.  It is zero when a
c         send command is first issued.  While the
c         frame is being sent, it is the pixel
c         count.
c         ----------------------------------------
c
       elseif (step .eq. 5) then
          if (sendct .eq. 0) then
             if     (sendsz .lt.   500) then
                i4 = 19
                sendsz = 361
             elseif (sendsz .lt.  2000) then
                i4 = 36
                sendsz = 1296
             elseif (sendsz .lt. 80000) then
                i4 = 250
                sendsz = 62500
             else
                i4 = 500
                sendsz = 250000
             endif
             ncol = i4
c
             frame = frame + 1
             if (frame .ge. 1000) frame = 101
             call vbox (58, frame)
             call vbox (59, 0)
c
c            ncol
c
             call swap4 (i4)
             xbuf (1) = i2 (1)
             xbuf (2) = i2 (2)
c
c            nrow
c
             xbuf (3) = i2 (1)
             xbuf (4) = i2 (2)
c
c            frame
c
             i4 = frame
             call swap4 (i4)
             xbuf (5) = i2 (1)
             xbuf (6) = i2 (2)
c
c            S-H mask flag
c
             i4 = shflag
             call swap4 (i4)
             xbuf (7) = i2 (1)
             xbuf (8) = i2 (2)
c
c            room for 10 longs in header
c            currently 6 spare
c
             nbuf = 40
             sendct = 1
             wbuf = 0
             wtime = timer1
             step = 6
c
c
c         Now put up to 512 pixels into the send
c         buffer.  If there aren't any pixels left
c         to send, the transfer is done.
c         ----------------------------------------
c
          elseif (sendct .gt. 0) then
             nbuf = sendsz - sendct + 1
             if     (nbuf .gt. 512) then
                nbuf = 512
             elseif (nbuf .lt.   1) then
                sendct = - 1
                go to 990
             endif
c
             do 220 ibuf = 1, nbuf
                j2 = sndbuf (sendct)
                call swap2 (j2)
                xbuf (ibuf) = j2
                sendct = sendct + 1
  220        continue
c
             nbuf = nbuf * 2
             wbuf = 0
             wtime = timer1
             step = 6
          endif
c
c
c         Send data to the TSR.
c         ---------------------
c
       elseif (step .eq. 6) then
          call blk_bm (xbuf1 (wbuf + 1), x'34', bufadr, nbuf - wbuf)
c
c
c         Set Flush Next Write.
c         ---------------------
c
          eax = x'0900'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
c
c
c         Write Socket.  If the number of bytes
c         written is less than nbuf, that's OK,
c         just write the rest of the buffer again.
c         -------------------------------------
c
          eax = x'0700'
          ebx = nbuf - wbuf
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
c
          wbuf = wbuf + eax
          if     (wbuf .eq. nbuf) then
             i4 = (sendct - 1) / ncol
             call vbox (59, i4)
             step = 5
          elseif (wbuf .lt. nbuf) then
             dtime = timer1 - wtime
             if (dtime .lt. 0) dtime = dtime + 1000000000
             if (dtime .gt. 3000) then
                if (errct .gt. 3) then
                   msg = '103: TCP write timeout error XXX YYY'
                   call iform (nbuf, msg (30:32), 1)
                   call iform (eax,  msg (34:36), 1)
                   call putmsg (msg)
                endif
                sendct = - 1
                step = 2
             endif
          else
             call putmsg ('105: TCP write socket overflow')
             sendct = - 1
             step = 2
          endif
c
       endif
c
c
c
c         Tick the socket.
c         ----------------
c
       if ((step .eq. 5) .or. (step .eq. 6)) then
          eax = x'0400'
          ebx = 0
          ecx = 0
          edx = 0
          call int097 (eax, ebx, ecx, edx)
          if (eax .ne. 0) then
             if (errct .lt. 3)
     :          call putmsg ('104: TCP connection broken')
             sendct = - 1
             step = 2
          endif
       endif
c
c
c         Keep track of error count.  There are
c         some long delays involved in establishing
c         the TCP/IP link which interfere with the
c         operation of the program.  So quit trying
c         if the error count gets too high.
c         -----------------------------------------
c
       if     (ok .eq. 1) then
          errct = 0
c
       elseif (ok .eq. 0) then
          errct = min (errct + 1, 4)
          if (errct .eq. 3) then
             call putmsg ('105: TCP communications suspended')
	     time2 = timer1
          endif
       endif
c
  990  continue
c
       return
       end
c
c
c         Invert byte order in a 4-byte integer.
c         --------------------------------------
c
       subroutine swap4 (arg)
c
       implicit none
c
       integer*4 arg, i4, j4
       integer*1 i1 (4), j1 (4)
c
       equivalence (i4, i1 (1)), (j4, j1 (1))
c
       i4 = arg
c
       j1 (4) = i1 (1)
       j1 (3) = i1 (2)
       j1 (2) = i1 (3)
       j1 (1) = i1 (4)
c
       arg = j4
c
       return
       end
c
c
c         Invert byte order in a 2-byte integer.
c         --------------------------------------
c
       subroutine swap2 (arg)
c
       implicit none
c
       integer*2 arg, i2, j2
       integer*1 i1 (2), j1 (2)
c
       equivalence (i2, i1 (1)), (j2, j1 (1))
c
       i2 = arg
c
       j1 (2) = i1 (1)
       j1 (1) = i1 (2)
c
       arg = j2
c
       return
       end
