c
c
c         cast a dummy argument into type
c         real*8, real*4 or integer*4
c
c            this really works when the
c            function type is declared
c            in the calling program!
c         -------------------------------
c
       real*8    function r8val (arg)
       real*8    arg
       r8val  =  arg
       return
       end
c
       real*4    function r4val (arg)
       real*4    arg
       r4val  =  arg
       return
       end
c
       integer*4 function i4val (arg)
       integer*4 arg
       i4val  =  arg
       return
       end
c
c
c         Return the font pointer to
c         the appropriate color:
c               0... black
c               1... red
c               2... yellow
c               3... green
c               4... white
c         --------------------------
c
       integer*4 function cptr (i)
c
       implicit none
c
       integer*4  i
       integer*4  blk1, gry1, wht1, red1
       integer*4  yel1, grn1, blk2, grn2
c
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
c
       if (i .eq. 0) then
          cptr = blk1
       elseif (i .eq. 1) then
          cptr = red1
       elseif (i .eq. 2) then
          cptr = yel1
       elseif (i .eq. 3) then
          cptr = grn1
       elseif (i .eq. 4) then
          cptr = wht1
       else
          cptr = gry1
       endif
c
       return
       end
c
c
c         clear and display big characters
c         --------------------------------
c
       subroutine bigtext (newmsg, oldmsg, ix, iy, font)
c
       implicit  none
c
       integer*4 ix, iy, font, jx
       integer*4 nch, i
       character newmsg*(*), oldmsg*(*)
c
       nch = len (newmsg)
       jx = ix
       do 220 i = 1, nch
          if (newmsg (i:i) .ne. oldmsg (i:i)) then
             call opqchr2 (newmsg (i:i), jx, iy, font)
          endif
          jx = jx + 16
  220  continue
c
       oldmsg = newmsg
       return
       end
c
c
c         clear and display small characters
c         ----------------------------------
c
       subroutine smalltext (newmsg, oldmsg, ix, iy, font)
c
       implicit  none
c
       integer*4 ix, iy, font, jx
       integer*4 nch, i
       character newmsg*(*), oldmsg*(*)
c
       nch = len (newmsg)
       jx = ix
       do 220 i = 1, nch
          if (newmsg (i:i) .ne. oldmsg (i:i)) then
             call opqchr1 (newmsg (i:i), jx, iy, font)
          endif
          jx = jx + 8
  220  continue
c
       oldmsg = newmsg
       return
       end
c
c
c
c         Format an integer*4 variable into a character string.
c         DON'T use Fortran format control, which is too slow.
c         Right-justify the digits into the string.
c         If the value doesn't fit, fill with asterisks.
c         If necessary, fill npl places with leading zeroes.
c
c         A six-digit number takes about 11 microseconds on a
c         50 MHz 486.  Format control takes about 90 microsec.
c         -----------------------------------------------------
c
       subroutine iform (ival, cval, npl)
c
       implicit none
c
       integer*4 ival, nchr, ichr
       integer*4 i, j, npl, test
       character cval*(*)
c
c
c          Get the string length,
c          and the sign.
c          ----------------------
c
       nchr = len (cval)
       if (nchr .lt. 1) go to 990
       ichr = nchr
       if (ival .lt. 0) then
          test = 1
          i = - ival
       else
          test = 0
          i = ival
       endif
c
c
c         Divide by 10 and make a
c         digit from the remainder.
c         -------------------------
c
  100  continue
       if (ichr .gt. test) then
          j = i / 10
          i = i - (10 * j)
          cval (ichr:ichr) = char (48 + i)
          i = j
          ichr = ichr - 1
          if (i .gt. 0) go to 100
c
c
c         Doesn't fit: fill with *'s
c         ---------------------------
c
       else
          do 200 ichr = 1, nchr
             cval (ichr:ichr) = '*'
  200     continue
          go to 990
       endif
c
c
c         Add leading zeroes if necessary.
c         --------------------------------
c
  300  continue
       if (npl .gt. (nchr - ichr)) then
          cval (ichr:ichr) = '0'
          ichr = ichr - 1
          if (ichr .gt. test) go to 300
       endif
c
c
c         Add minus sign if necessary.
c         ----------------------------
c
       if (test .eq. 1) then
          cval (ichr:ichr) = '-'
          ichr = ichr - 1
       endif
c
c
c         Add blanks if necessary.
c         ------------------------
c
  400  continue
       if (ichr .gt. 0) then
          cval (ichr:ichr) = ' '
          ichr = ichr - 1
          go to 400
       endif
c
  990  continue
       return
       end
c
c
c
c         Format a real*4 variable into a character string.
c         DON'T use Fortran format control, which is too slow.
c         Right-justify the digits into the string.  If the
c         value doesn't fit, fill with asterisks.  The number
c         of decimal places is ndc, which MUST have a value in
c         the range 1...9.  If necessary, fill npl places with
c         leading zeroes.
c
c         A four-digit number (2 before decimal point, 2 after)
c         takes about 13 microsec on a 50 MHz 486.  Format
c         control takes 130 microsec.
c         -----------------------------------------------------
c
       subroutine fform (rval, cval, ndc, npl)
c
       implicit none
c
       real*4    rval, r, r10 (9)
       integer*4 ival, nchr, ichr
       integer*4 i, j, ndc, npl, test
       character cval*(*)
c
       data r10 / 1.e1, 1.e2, 1.e3, 1.e4, 1.e5,
     :            1.e6, 1.e7, 1.e8, 1.e9 /
c
c
c          Get the string length,
c          and the sign.
c          ----------------------
c
       nchr = len (cval)
       if (nchr .lt. 1) go to 990
       ichr = nchr
       if (rval .lt. 0.) then
          test = 1
          r = - rval * r10 (ndc)
       else
          test = 0
          r = rval * r10 (ndc)
       endif
c
c
c         Convert to an integer.
c         ----------------------
c
       if (r .lt. 2.14748e9) then
          i = nint (r)
       else
          go to 950
       endif
c
c
c         Divide by 10 and make a
c         digit from the remainder.
c         -------------------------
c
  100  continue
       if (ichr .gt. test) then
          j = i / 10
          i = i - (10 * j)
          cval (ichr:ichr) = char (48 + i)
          i = j
          ichr = ichr - 1
          if ((ichr + ndc) .eq. nchr) then
             cval (ichr:ichr) = '.'
             ichr = ichr - 1
          endif
          if (i .gt. 0) go to 100
c
c
c         Doesn't fit: fill with *'s
c         ---------------------------
c
       else
          go to 950
       endif
c
c
c         Add leading zeroes if necessary.
c         --------------------------------
c
  300  continue
       if (npl .gt. (nchr - ichr - ndc - 1)) then
          cval (ichr:ichr) = '0'
          ichr = ichr - 1
          if ((ichr + ndc) .eq. nchr) then
             cval (ichr:ichr) = '.'
             ichr = ichr - 1
          endif
          if (ichr .gt. test) go to 300
       endif
c
c
c         Add minus sign if necessary.
c         ----------------------------
c
       if (test .eq. 1) then
          cval (ichr:ichr) = '-'
          ichr = ichr - 1
       endif
c
c
c         Add blanks if necessary.
c         ------------------------
c
  400  continue
       if (ichr .gt. 0) then
          cval (ichr:ichr) = ' '
          ichr = ichr - 1
          go to 400
       endif
       go to 990
c
c
c         Asterisk-fill.
c         --------------
c
  950  continue
       do 960 ichr = 1, nchr
          cval (ichr:ichr) = '*'
  960  continue
c
  990  continue
       return
       end
c
c
c         Decode a hexadecimal number.
c         val = integer*4 result.
c         hex = integer*1 array or string
c               variable in hexadecimal format.
c         nd  = number of digits (max = 8).
c         -------------------------------------
c
       logical*4 function hexval (val, hex, nd)
c
       integer*4 val, p16 (8)
       integer*4 i, ip, nd, sum, cval
c
       integer*1 hex (1)
c
       data p16 /      1,      16,      256,      4096,
     :             65536, 1048576, 16777216, 268435456 /
c
       ip   = nd
c
c
c         Value is positive.
c         ------------------
c
       if (hex (1) .lt. 56) then
          sum = 0
          do 190 i = 1, nd
             cval = hex (i)
             if     ((cval .gt. 47) .and. (cval .lt. 58)) then
                sum = sum + (p16 (ip) * (cval - 48))
             elseif ((cval .gt. 64) .and. (cval .lt. 71)) then
                sum = sum + (p16 (ip) * (cval - 55))
             else
                hexval = .false.
                return
             endif
             ip = ip - 1
  190     continue
c
c
c         Value is negative.
c         ------------------
c
       else
          sum = - 1
          do 290 i = 1, nd
             cval = hex (i)
             if     ((cval .gt. 47) .and. (cval .lt. 58)) then
                sum = sum - (p16 (ip) * (63 - cval))
             elseif ((cval .gt. 64) .and. (cval .lt. 71)) then
                sum = sum - (p16 (ip) * (70 - cval))
             else
                hexval = .false.
                return
             endif
  290     continue
          ip = ip - 1
       endif
c
       hexval = .true.
       val = sum
       return
       end
c
c
c         Encode an integer to a
c         6-bit character.
c         ----------------------
c
       character*1 function c6bit (i4)
c
       implicit  none
c
       integer*4 i4, i6
c
       i6 = and (i4, x'3F')
       if     (i6 .le.  9) then
          c6bit = char (i6 + 48)
       elseif (i6 .le. 35) then
          c6bit = char (i6 + 55)
       elseif (i6 .le. 61) then
          c6bit = char (i6 + 61)
       elseif (i6 .eq. 62) then
          c6bit = char (38)
       elseif (i6 .eq. 63) then
          c6bit = char (63)
       endif
c
       return
       end
c
c
c         Decode a 6-bit character
c         to integer.
c         ------------------------
c

       integer*4 function i6bit (chr)
c
       implicit  none
c
       integer*4 i4
       character chr*1
c
       i4 = ichar (chr)
       if     (i4 .eq.  38) then
          i6bit = 62
       elseif (i4 .eq.  63) then
          i6bit = 63
       elseif (i4 .le.  47) then
          i6bit = 0
       elseif (i4 .le.  57) then
          i6bit = i4 - 48
       elseif (i4 .le.  64) then
          i6bit = 0
       elseif (i4 .le.  90) then
          i6bit = i4 - 55
       elseif (i4 .le.  96) then
          i6bit = 0
       elseif (i4 .le. 122) then
          i6bit = i4 - 61
       else
          i6bit = 0
       endif
c
       return
       end
