c
c
c         Initialize variables for VGA display.
c         -------------------------------------
c
       subroutine scpdat
c
       integer*4 opg, dpg, lx, ly, lxy
c
       common / scpcom / opg, dpg, lx, ly, lxy
c
       data  opg / 0 /, dpg / 17 /, lx / 640 /, ly / 480 /
       data  lxy / 307200 /
c
       return
       end
c
c
c         Set color palette for VGA display.
c         ----------------------------------
c
       subroutine map
c
       implicit none
c
       integer*4 val, i, j, k
c
       val = 0
       do 100 i = 0, 63
          k = (3 * i) / 4
          j = (k + i) / 2
          call wrpal (i, j, k, i + 16)
  100  continue
c
       do 200 i = 0, 15
          j = (i * 4) + 3
          k = (3 * j) / 4
          call wrpal (j, 0, 0, i +  80)
          call wrpal (j, k, 0, i +  96)
          call wrpal (0, j, 0, i + 112)
          call wrpal (i, i, j, i + 128)
  200  continue
c
       return
       end
c
       subroutine wrpal (r, g, b, n)
c
       integer*4 r, g, b, n
c
       call outp (x'3C8', n)
       call outp (x'3C9', r)
       call outp (x'3C9', g)
       call outp (x'3C9', b)
c
       return
       end
c
c
c         Set up a fast graphics font.
c         ----------------------------
c
       subroutine fontset (fontbuf, fgd, bkg, size)
c
       implicit none
c
       integer*4 size, seg, off, adr
       integer*4 irom, ifast, ibit
       integer*4 i1, peekb
       integer*1 fontbuf (1), fgd, bkg
c
c
c         Find the address of the 8 x 16 ROM font.
c         The segment is not returned correctly,
c            (because of protected mode?) so use
c            C000, which is the VGA ROM segment.
c         Use integer*4 for seg, off to avoid sign
c            problems.
c         ----------------------------------------
c
c
       seg = 0
       off = 0
       call fontadr (6, seg, off)
       adr = (16 * x'C000') + off
c
c
c         For a normal-sized font, each BIT of the
c            original goes into one BYTE of the fast
c            font.  The byte value = fgd if the bit
c            is 1, and = bkg if the bit is 0.
c         ------------------------------------------
c
       if (size .eq. 1) then
          ifast = 0
          do 120 irom = 0, 4095
             i1 = peekb (adr + irom)
c
             ifast = ifast + 1
             if (and (i1, x'80') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'40') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'20') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'10') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'08') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'04') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'02') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
             ifast = ifast + 1
             if (and (i1, x'01') .eq. 0) then
                fontbuf (ifast) = bkg
             else
                fontbuf (ifast) = fgd
             endif
c
  120     continue
c
c
c         For a double-sized font, each bit of the
c            ROM font determines 4 bits of the fast
c            font.
c         -----------------------------------------
c
       elseif (size .eq. 2) then
          ifast = - 1
          do 140 irom = 0, 4095
             i1 = peekb (adr + irom)
c
             ifast = ifast + 2
             if (and (i1, x'80') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'40') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'20') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'10') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'08') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'04') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'02') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 2
             if (and (i1, x'01') .eq. 0) then
                fontbuf (ifast)      = bkg
                fontbuf (ifast +  1) = bkg
                fontbuf (ifast + 16) = bkg
                fontbuf (ifast + 17) = bkg
             else
                fontbuf (ifast)      = fgd
                fontbuf (ifast +  1) = fgd
                fontbuf (ifast + 16) = fgd
                fontbuf (ifast + 17) = fgd
             endif
c
             ifast = ifast + 16
  140     continue
c
       endif
c
       return
       end
c
c
c         Draw an opaque 8 x 16 character
c            string in 8-bit graphics mode.
c         No checking -- so get it right
c            the first time!
c         ---------------------------------
c
       subroutine opqchr1 (string, x, y, fontbuf)
c
       implicit none
c
       integer*4 x, y, fontptr, ix, iy, istr, nstr
       integer*4 pgbeg, pgendf, pgend8, pglen, pgreg
       integer*4 opg, dpg, lx, ly, lxy
       integer*4 i4, j4
       integer*2 i2 (2)
       integer*1 fontbuf (1), j1
       character string*(*)
c
       common / scpcom / opg, dpg, lx, ly, lxy
c
       equivalence (i4, i2), (j4, j1)
c
       data pgbeg / x'A0000' /, pgendf / x'AFFFF' /
       data pglen / x'10000' /, pgend8 / x'AFFF8' /
       data j4 / 0 /
c
       istr   = 1
       nstr   = len (string)
       i4     = x + (lx * y)
       pgreg  = i2 (2)
       i2 (2) = 10
       call outp (x'3CD', pgreg)
       j1 = ichar (string (1:1))
       fontptr = 1 + (128 * j4)
c
  200  continue
       do 240 iy = 1, 16
          if (i4 .le. pgend8) then
             call blk_bm (fontbuf (fontptr), x'34', i4, 8)
             fontptr = fontptr + 8
             i4 = i4 + lx
          else
             do 220 ix = 1, 8
                call pokeb (i4, fontbuf (fontptr))
                i4 = i4 + 1
                fontptr = fontptr + 1
                if (i4 .gt. pgendf) then
                   pgreg = pgreg + 1
                   call outp (x'3CD', pgreg)
                   i4 = pgbeg
                endif
  220        continue
             i4 = i4 - 8 + lx
          endif
          if (i4 .gt. pgendf) then
             pgreg = pgreg + 1
             call outp (x'3CD', pgreg)
             i4 = i4 - pglen
          endif
  240  continue
c
       if (istr .lt. nstr) then
          istr = istr + 1
          j1 = ichar (string (istr:istr))
          fontptr = 1 + (128 * j4)
          i4 = i4 + 8 - (16 * lx)
          if (i4 .lt. pgbeg) then
             pgreg = pgreg - 1
             call outp (x'3CD', pgreg)
             i4 = i4 + pglen
          endif
          go to 200
       endif
c
       return
       end
c
c
c         Draw an opaque 16 x 32 character
c            string in 8-bit graphics mode.
c         No checking -- so get it right
c            the first time!
c         ---------------------------------
c
       subroutine opqchr2 (string, x, y, fontbuf)
c
       implicit none
c
       integer*4 x, y, fontptr, ix, iy, istr, nstr
       integer*4 pgbeg, pgendf, pgend0, pglen, pgreg
       integer*4 opg, dpg, lx, ly, lxy
       integer*4 i4, j4
       integer*2 i2 (2)
       integer*1 fontbuf (1), j1
       character string*(*)
c
       common / scpcom / opg, dpg, lx, ly, lxy
c
       equivalence (i4, i2), (j4, j1)
c
       data pgbeg / x'A0000' /, pgendf / x'AFFFF' /
       data pglen / x'10000' /, pgend0 / x'AFFF0' /
       data j4 / 0 /
c
       istr   = 1
       nstr   = len (string)
       i4     = x + (lx * y)
       pgreg  = i2 (2)
       i2 (2) = 10
       call outp (x'3CD', pgreg)
       j1 = ichar (string (1:1))
       fontptr = 1 + (512 * j4)
c
  200  continue
       do 240 iy = 1, 32
          if (i4 .le. pgend0) then
             call blk_bm (fontbuf (fontptr), x'34', i4, 16)
             fontptr = fontptr + 16
             i4 = i4 + lx
          else
             do 220 ix = 1, 16
                call pokeb (i4, fontbuf (fontptr))
                i4 = i4 + 1
                fontptr = fontptr + 1
                if (i4 .gt. pgendf) then
                   pgreg = pgreg + 1
                   call outp (x'3CD', pgreg)
                   i4 = pgbeg
                endif
  220        continue
             i4 = i4 - 16 + lx
          endif
          if (i4 .gt. pgendf) then
             pgreg = pgreg + 1
             call outp (x'3CD', pgreg)
             i4 = i4 - pglen
          endif
  240  continue
c
       if (istr .lt. nstr) then
          istr = istr + 1
          j1 = ichar (string (istr:istr))
          fontptr = 1 + (512 * j4)
          i4 = i4 + 16 - (32 * lx)
          if (i4 .lt. pgbeg) then
             pgreg = pgreg - 1
             call outp (x'3CD', pgreg)
             i4 = i4 + pglen
          endif
          go to 200
       endif
c
       return
       end
c
